#!/usr/bin/env python
from dttcmd import *

func_arg_list = [
[2, 0], [1, 0], [3, 1], [1, 1], [4, 0], 
[0, 1], [0, 1], [0, 1], [3, 0], [2, 0], 
[2, 0], [1, 0], [1, 0], [4, 0], [3, 0], 
[4, 0], [2, 0], [2, 0], [2, 0], [3, 0], 
[0, 0], [2, 2], [4, 0], [3, 0], [0, 0],
]

cvt_dict = {
    'evheight_p' : 0,   #-417    ;eng vheight p,q
        'tvheight_lu' : 0,   #-417    ;eng vheight p,q
    'vbase'     : 1,   #0            ;all vbase
    'tvheight_num' : 2,   #908    ;thai vheight number
    'evheight'  : 3,   #1062       ;eng vheight normal
    'tvheight'  : 4,   #1140       ;thai vheight normal
    'ecvheight' : 5,   #1450      ;eng capital vheight normal
    'tstemtc'   : 6,   #160         ;thai stem thick - curve
        'ecstemt_thin'  :   6,   #160         ;thai stem thick - curve
    'cvt_7'     : 7,   #112
        'tstemt_sara' : 7,   #112      ;stem thick of sara
    'estem_124'     : 8,   #124
    'headstem'  : 9,   #130        ;head stem width/thick
        'tstemw_sara' : 9,   #130      ;stem width of sara
    'estemt'    : 10,   #148         ;eng stem thick
        'tstemt' : 10,   #148         ;thai stem thick
    'estemw_thin'    : 11,   #164
    'estem_168'    : 12,   #168
    'ecstemt'   : 13,   #173        ;eng cap stem thick
    'ecstemtc'  : 14,   #180        
    'headstem_thick' : 15,   #160 ;head stem - thick
    'estemw'    : 16,   #180         ;eng stem width
        'tstemw' : 16,   #180         ;thai stem width
    'cvt_17'    : 17,   #175
    'ecstemw'   : 18,   #191
    'cvt_19'    : 19,   #193
    'cvt_20'    : 20,   #201
    'ecstemwc'    : 21,   #197
    'cvt_22'    : 22,   #138
    'cvt_23'    : 23,   #144
    'cvt_24'    : 24,   #178
    'cvt_25'    : 25,   #152
    'estemtc'   : 26,   #156
        'tstemt_thin'    : 26,   #156
        'tstemtc_thin'    : 26,   #156
        'estemtc_thin'    : 26,   #156
    'cvt_27'    : 27,   #154
    'cvt_28'    : 28,   #103
        'head_sara_stem' : 28,   #103
    'cvt_29'    : 29,   #142
    'cvt_30'    : 30,   #122
#USER LAND
    'evbase_shoot' : 31,   #24
        'tvbase_shoot' : 31,   #24
    #'cvt_32'    : 32,   #932
    'tvheight_num_shoot':32,#936
    'evheight_shoot':33,    #1088
    'tvheight_shoot':34,    #1166
    'ecvheight_shoot':35,   #1479
    'hsph'          :36, #300   #headstemplushole
    'headdia'       :37, #430
    'tvheight_po': 38,  #1477
        'evheight_b': 38,  #1477
    'head_sara': 39,    #334
    'cvt_40' : 40,   #0
    'cvt_41' : 41,   #101
    'estemwc'   :42,    #186
    'estem_205' :43,    #205
    'cvt_44'    :44,    #0
    'cvt_45'    :45,    #0
    'cvt_46'    :46,    #0
    'cvt_47'    :47,    #0
    'cvt_48'    :48,    #0
    'cvt_49'    :49,    #0
    'cvt_50'    :50,    #0
    }

#PUT THESE LINE IN THE BOTTOM OF CODE
#   #----- MODIFY pseudo_code_dict BY -----------
#   #----- SUBSTITUTE FUNCTION IN TEXT FORM -----
#   #----- TO REAL pseudo_code ------------------
#   from dttcmd import *
#   self_func = []
#   for i in dir():
#       if callable(eval(i)): self_func.append(i)
#   
#   
#   for i in pseudo_code_dict.keys():
#       p_list = pseudo_code_dict[i].sp_listit('\n')
#       for j in range(len(p_list)):
#           if '(' in p_list[j]:
#               if p_list[j].sp_listit('(',1)[0] in self_func:
#                   l = [n for n in range(len(p_list[j])) if p_list[j][n] == ')']
#                   t = p_list[j][:l[-1]+1]
#                   p_list[j] = p_list[j].rep_listace(t, eval(t))
#       pseudo_code_dict[i] = '\n'.join(p_list)

#----------------------------------------
#   code
#----------------------------------------


#----------------------------------------

#---GENERATE STEM FUNCTION---
#predefine delta string of stem (put before gen_cvt_func)
#ds_headstem = "9-4 30-4 31-4 32-4 33-4 34-4 "
#ds_hsph = "9-4 30+4 31+4 32-4 33-4 34-4 "
#ds_headsara = "9-4 "
#
#MOVE TO prep table
#ds_headstem = "9-1 10+3 11+2 12+2 13+1 17-1 18-2 19-1 20-2 21-2 22-3 23-3 24-4 25-4 26-4 27-4 28-4 31-1 32-1 40-4 "
#ds_headdia = "9-8 12-8 13-8 17-8 18-8 22-8 23-8 27-8 28-8 31-8 32-8 36-8 37-8 "
#ds_hsph = "16-3 17-3 18-4 24-4 25-4 26-4 27-4 28-4 31-8 32-8 "
#ds_hsph = "9-4 10-4 11-4 12-4 13-4 16-3 17-3 18-4 19+2 23-2 24+4 25+3 26+2 27+1 28-4 31-4 32-4 "
#ds_head_sara = "15+8 "
#ds_head_sara_stem = "9-4 "
#MOVE TO prep
#ds_estemw = ds_tstemw = "12-1 13-1 14-2 15-2 16-2 "
#ds_estemt = ds_tstemt = "14-1 15-1 16-2 "
#ds_estemtc = ds_tstemtc = "14-1 15-2 16-3 "
#
#ds_estemt_thin = ds_tstemt_thin = "14-2 15-2 16-3 " #EXTRA FOR THIN
#ds_estemt_thin = ds_tstemtc_thin = "14-2 15-3 16-3 " #EXTRA FOR THIN

#SPECIAL
ds_slant = "11-1 12-2 13-2 14-3 15-3 16-4 "
ds_ec_slant = "11-1 12-2 13-3 14-3 15-4 16-5 "

#AUTO THIN DELTA STRING, USE IN AUTO GENERATE stemt FUNCTION
ds_autothin = "14-1 15-1 16-1 "
#
gen_cvt_func_dict = {
    #MIRP[min,black]
#    'mirp-mb':   ['ecstem*','estem*','tstem*','stem*','headdia'],
'mirp-mb':   ['ecstemw*','estemw*','tstemw*','stemw*','headdia','estem_*'],
    #MIRP[min,rnd,grey]
    #'mirp-mrg':  ['headdia','headstem*','head_sara_stem','head_sara'],
    #MIRP[white]
    'mirp-w':  ['headhole'],
    #MIRP[grey]
    'mirp-g':  ['hsph'],
    #MIRP[black]
#    'mirp-b' : ['headstem*','head_sara_stem','head_sara'],
'mirp-b' : ['headstem*','head_sara_stem','head_sara','ecstemt*','estemt*','tstemt*','stemt*'],
    #MIAP[rnd]
    'miap-r' : ['evheight*','tvheight*','ecvheight*','evbase*'],
    }

#create function from cvt value
#ex: estemw
#   -> estemw_1  = mirpmb('estemw',ds_estemw,direction='+')
#   -> estemw0_1 = mirp0mb('estemw',ds_estemw,direction='+')
#   -> estemw_2  = mirpmb('estemw',ds_estemw,direction='-')
#   -> estemw0_2 = mirp0mb('estemw',ds_estemw,direction='-')
for arg,cvt_list in gen_cvt_func_dict.iteritems():
    new_list = []
    for i in cvt_list:
        if i[-1]=='*': 
            c = i.strip('*')
            n = len(c)
            l = [x for x in cvt_dict.keys() if x[:n]==c]
            new_list.extend(l)
        else:
            new_list.append(i)

    for i in new_list:
        for j in ['_1','0_1','_2','0_2']:
           #1=forward/bottomup, #2=reverse/topdown
            add1 = ''
            if arg[:4] == 'call':
                cmd_line = '"%s %s ' % (arg.upper(),i,) + '%s" ' + '% (s,)'
                if j[0] == '0':
                    add1 = 'srp0(s)'
            else:
                c,a = arg.split('-')
                if c in ['miap','mdap']:
                    if j[0] == '0':
                        cmd = c + a
                    else:
                        #MIAP and MDAP the point must be rp0 only
                        continue
                else:
                    if j[0] == '0':    #m=move rp0
                        cmd = c + '0' + a
                    else:
                        cmd = c + a
                cmd_line = '%s("%s",s)' % (cmd,i,)  #mirp('cvt',s)

            if j[-1] == '1': #1=forward/bottomup, #2=reverse/topdown
                direction = '+'
            else:
                direction = '-'

            #AUTO GENERATE delta string
            try:    #if ds_CVT is defined
                exec "ds = ds_%s " % (i,)
            except: #else
                exec "ds_%s = ''" % (i,)

            #GEN FUNCTION
            exec '''def %s%s(s,direction="%s"):
    return pl(""
        , %s
        , f_dstr(s,ds_%s,direction)
        , %s
        )
''' % (i,j,direction,cmd_line,i,add1,)

            #GEN EXTRA FUNC FOR THIN OF estemt, tstemt
            #USE IN UPPER STEM OF kho_khai, kho_kwai
            #***PREDEFINE: ds_estemt_autothin
            #if arg[:4] == 'mirp' and i in ['ecstemt','ecstemtc','estemt','estemtc','tstemt','tstemtc']:
            if i in ['ecstemt','ecstemtc','estemt','estemtc','tstemt','tstemtc']:
                #AUTO GENERATE delta string
                try:
                    exec "ds_%s_autothin = sum_dstr(ds_%s + ds_autothin" % (i,i,)
                except:
                    exec "ds_%s_autothin = ds_autothin" % (i,)
                #GEN FUNC
                exec '''def %s_autothin%s(s,direction="%s"):
    return pl(""
        , %s
        , f_dstr(s,ds_%s_autothin,direction)
        )
''' % (i,j,direction,cmd_line,i,)


pseudo_prep = pl("""
    f_push      511        ;#--- PUSHW_1    511        ;: PUSH Words
SCANCTRL        &_511      ;511: SCAN conversion ConTRoL
    f_push      1          ;#--- PUSHB_1    1          ;: PUSH Bytes
SCANTYPE        &_1        ;1: SCANTYPE
SVTCA[y-axis]              ;: Set freedom and projection Vectors To Coordinate Axis
MPPEM                      ;: Measure Pixels Per EM
    f_push      8          ;#--- PUSHB_1    8          ;&_MPPEM_1: PUSH Bytes
LT              &_8 &_MPPEM_1 ;8 &_MPPEM_1: Less Than
IF              &_LT_1     ;&_LT_1: IF test
    f_push      1 1        ;#--- PUSHB_2    1 1        ;: PUSH Bytes
INSTCTRL        &_1 &_1    ;1 1: INSTRuction execution ConTRoL
EIF                        ;  : End IF
#    f_push      6 70       ;#--- PUSHB_2    70 6       ;: PUSH Bytes
#CALL            &_6        ;6 70: CALL function
#IF              &_f6_retval_1 ;&_f6_retval_1 70: IF test
#POP             &_70       ;70: POP top stack element
#    f_push      16         ;#--- PUSHB_1    16         ;: PUSH Bytes
#EIF                        ;16: End IF
#MPPEM                      ;16: Measure Pixels Per EM
#    f_push      20         ;#--- PUSHB_1    20         ;&_MPPEM_1 16: PUSH Bytes
#GT              &_20 &_MPPEM_1 ;20 &_MPPEM_1 16: Greater Than
#IF              &_GT_1     ;&_GT_1 16: IF test
#POP             &_16       ;16: POP top stack element
#    f_push      128        ;#--- PUSHB_1    128        ;: PUSH Bytes
#EIF                        ;128: End IF
#SCVTCI          &_128      ;128: Set Control Value Table Cut-In
    f_push      6          ;#--- PUSHB_1    6          ;: PUSH Bytes
#CALL            &_6        ;6: CALL function
#NOT             &_f6_retval_1 ;&_f6_retval_1: logical NOT
#IF              &_NOT_1    ;&_NOT_1: IF test
#SVTCA[y-axis]              ;: Set freedom and projection Vectors To Coordinate Axis
#    f_push      6          ;#--- PUSHB_1    6          ;: PUSH Bytes
#DUP             &_6        ;6: DUPlicate top stack element
#RCVT            &_DUP_1    ;&_DUP_1 &_DUP_2: Read Control Value Table entry
#    f_push      3          ;#--- PUSHB_1    3          ;&_RCVT_1 &_DUP_2: PUSH Bytes
#CALL            &_3 &_RCVT_1 ;3 &_RCVT_1 &_DUP_2: CALL function
#WCVTP           &_f3_retval_1 &_DUP_2 ;&_f3_retval_1 &_DUP_2: Write Control Value Table in Pixel units
#    f_push      9          ;#--- PUSHB_1    9          ;: PUSH Bytes
#DUP             &_9        ;9: DUPlicate top stack element
#RCVT            &_DUP_1    ;&_DUP_1 &_DUP_2: Read Control Value Table entry
#    f_push      2 99 6     ;#--- PUSHB_3    6 99 2     ;&_RCVT_1 &_DUP_2: PUSH Bytes
#CALL            &_2 &_99 &_6 &_RCVT_1 ;2 99 6: CALL function
#    f_push      3          ;#--- PUSHB_1    3          ;&_f2_retval_1 &_DUP_2: PUSH Bytes
#CALL            &_3 &_f2_retval_1 ;3 &_f2_retval_1 &_DUP_2: CALL function
#WCVTP           &_f3_retval_1 &_DUP_2 ;&_f3_retval_1 &_DUP_2: Write Control Value Table in Pixel units
#    f_push      8          ;#--- PUSHB_1    8          ;: PUSH Bytes
#DUP             &_8        ;8: DUPlicate top stack element
#RCVT            &_DUP_1    ;&_DUP_1 &_DUP_2: Read Control Value Table entry
#    f_push      2 24 9     ;#--- PUSHB_3    9 24 2     ;&_RCVT_1 &_DUP_2: PUSH Bytes
#CALL            &_2 &_24 &_9 &_RCVT_1 ;2 24 9: CALL function
#    f_push      3          ;#--- PUSHB_1    3          ;&_f2_retval_1 &_DUP_2: PUSH Bytes
#CALL            &_3 &_f2_retval_1 ;3 &_f2_retval_1 &_DUP_2: CALL function
#WCVTP           &_f3_retval_1 &_DUP_2 ;&_f3_retval_1 &_DUP_2: Write Control Value Table in Pixel units
#    f_push      7          ;#--- PUSHB_1    7          ;: PUSH Bytes
#DUP             &_7        ;7: DUPlicate top stack element
#RCVT            &_DUP_1    ;&_DUP_1 &_DUP_2: Read Control Value Table entry
#    f_push      2 15 8     ;#--- PUSHB_3    8 15 2     ;&_RCVT_1 &_DUP_2: PUSH Bytes
#CALL            &_2 &_15 &_8 &_RCVT_1 ;2 15 8: CALL function
#    f_push      3          ;#--- PUSHB_1    3          ;&_f2_retval_1 &_DUP_2: PUSH Bytes
#CALL            &_3 &_f2_retval_1 ;3 &_f2_retval_1 &_DUP_2: CALL function
#WCVTP           &_f3_retval_1 &_DUP_2 ;&_f3_retval_1 &_DUP_2: Write Control Value Table in Pixel units
#SVTCA[x-axis]              ;: Set freedom and projection Vectors To Coordinate Axis
#    f_push      10         ;#--- PUSHB_1    10         ;: PUSH Bytes
#DUP             &_10       ;10: DUPlicate top stack element
#RCVT            &_DUP_1    ;&_DUP_1 &_DUP_2: Read Control Value Table entry
#    f_push      3          ;#--- PUSHB_1    3          ;&_RCVT_1 &_DUP_2: PUSH Bytes
#CALL            &_3 &_RCVT_1 ;3 &_RCVT_1 &_DUP_2: CALL function
#WCVTP           &_f3_retval_1 &_DUP_2 ;&_f3_retval_1 &_DUP_2: Write Control Value Table in Pixel units
#    f_push      11         ;#--- PUSHB_1    11         ;: PUSH Bytes
#DUP             &_11       ;11: DUPlicate top stack element
#RCVT            &_DUP_1    ;&_DUP_1 &_DUP_2: Read Control Value Table entry
#    f_push      2 32767 10 ;#--- PUSHW_3    10 32767 2  ;&_RCVT_1 &_DUP_2: PUSH Words
#CALL            &_2 &_32767 &_10 &_RCVT_1 ;2 32767 10: CALL function
#    f_push      70 3       ;#--- PUSHB_2    3 70       ;&_f2_retval_1 &_DUP_2: PUSH Bytes
#SROUND          &_70       ;70 3 &_f2_retval_1: Super ROUND
#CALL            &_3 &_f2_retval_1 ;3 &_f2_retval_1 &_DUP_2: CALL function
#WCVTP           &_f3_retval_1 &_DUP_2 ;&_f3_retval_1 &_DUP_2: Write Control Value Table in Pixel units
#    f_push      12         ;#--- PUSHB_1    12         ;: PUSH Bytes
#DUP             &_12       ;12: DUPlicate top stack element
#RCVT            &_DUP_1    ;&_DUP_1 &_DUP_2: Read Control Value Table entry
#    f_push      2 89 11    ;#--- PUSHB_3    11 89 2    ;&_RCVT_1 &_DUP_2: PUSH Bytes
#CALL            &_2 &_89 &_11 &_RCVT_1 ;2 89 11: CALL function
#    f_push      70 3       ;#--- PUSHB_2    3 70       ;&_f2_retval_1 &_DUP_2: PUSH Bytes
#SROUND          &_70       ;70 3 &_f2_retval_1: Super ROUND
#CALL            &_3 &_f2_retval_1 ;3 &_f2_retval_1 &_DUP_2: CALL function
#WCVTP           &_f3_retval_1 &_DUP_2 ;&_f3_retval_1 &_DUP_2: Write Control Value Table in Pixel units
#EIF                        ;  : End IF
#    f_push      20         ;#--- PUSHB_1    20         ;: PUSH Bytes
#CALL            &_20       ;20: CALL function
#F#
"""
, sx()
, fc_dstr('ecstemw',"11-1 12-2 13-3 14-3 15-4 16-4 ")
, fc_dstr('ecstemwc',"11-1 12-2 13-3 14-3 15-4 16-5 ")
, fc_dstr('estemw',"12-1 13-1 14-2 15-2 16-3 ")    #tstemw
, fc_dstr('estemwc',"12-1 13-2 14-3 15-3 16-4 ")
, '#F#'
, sy()
, fc_dstr('ecstemt',"13-1 14-2 15-2 16-3 ")
, fc_dstr('ecstemtc',"12-1 13-2 14-2 15-3 16-4 ")
, fc_dstr('estemt',"14-1 15-1 16-2 ")       #tstemt 
, fc_dstr('estemtc',"14-1 15-2 16-3 ")      #tstemtc 
, fc_dstr('tstemt_thin',"14-1 15-1 16-2 ")       #tstemt 
#
, fc_dstr('evheight', "16+8 18+8 20+8 22+8 24+8 26+8 33+8 35+8 37+8 39+8 41+8 ")       #
, fc_dstr('ecvheight', "9+8 16+8 19+8 23+8 26+8 30+8 32+8 33+8 34+8 36+8 37+8 40+8 41+8 ")       #
, fc_dstr('ecvheight_shoot', "27-8 ")
, fc_dstr('headstem' , "9-1 10+3 11+3 12+2 13+1 16-1 17-1 18-1 19-1 20-2 21-3 22-3 23-3 24-2 25-2 26-2 27-2 28-3 29-2 30-2 31-1 32-1 40-4 ")
, fc_dstr('hsph', "9-4 10-4 11-4 12-6 13-8 15-1 16-2 17-3 18-4 19+2 20+1 22-1 23-2 24+1 25-1 26-2 27-3 28-2 29+2 31-2 32-2 35-1 ")
, fc_dstr('headdia', "9-8 12-8 13-8 17-8 18-8 22-8 23-8 27-8 28-8 31-8 32-8 36-8 37-8 ")
#, fc_dstr('head_sara', "15+8 ")
    )

pseudo_fpgm = """
    f_push      0          ;#--- PUSHB_1    0          ;: PUSH Bytes
FDEF &_0        ;0: Function DEFinition
    f_push      0          ;#--- PUSHB_1    0          ;: PUSH Bytes
SZP0            &_0        ;0: Set Zone Pointer 0
MPPEM                      ;: Measure Pixels Per EM
    f_push      42         ;#--- PUSHB_1    42         ;&_MPPEM_1: PUSH Bytes
LT              &_42 &_MPPEM_1 ;42 &_MPPEM_1: Less Than
IF              &_LT_1     ;&_LT_1: IF test
    f_push      74         ;#--- PUSHB_1    74         ;: PUSH Bytes
SROUND          &_74       ;74: Super ROUND
EIF                        ;  : End IF
    f_push      0          ;#--- PUSHB_1    0          ;: PUSH Bytes
SWAP            &_0 &_arg_1 ;0: SWAP the top two elements on the stack
MIAP[rnd]       &_SWAP_1 &_SWAP_2 ;&_SWAP_1 &_SWAP_2: Move Indirect Absolute Point
RTG                        ;: Round To Grid
    f_push      6          ;#--- PUSHB_1    6          ;: PUSH Bytes
CALL            &_6        ;6: CALL function
IF              &_f6_retval_1 ;&_f6_retval_1: IF test
RTDG                       ;: Round To Double Grid
EIF                        ;  : End IF
MPPEM                      ;: Measure Pixels Per EM
    f_push      42         ;#--- PUSHB_1    42         ;&_MPPEM_1: PUSH Bytes
LT              &_42 &_MPPEM_1 ;42 &_MPPEM_1: Less Than
IF              &_LT_1     ;&_LT_1: IF test
RDTG                       ;: Round Down To Grid
EIF                        ;  : End IF
DUP             &_arg_2    ;: DUPlicate top stack element
MDRP[rp0,rnd,grey] &_DUP_1    ;&_DUP_1 &_DUP_2: Move Direct Relative Point
    f_push      1          ;#--- PUSHB_1    1          ;&_DUP_2: PUSH Bytes
SZP0            &_1        ;1 &_DUP_2: Set Zone Pointer 0
MDAP[no-rnd]    &_DUP_2    ;&_DUP_2: Move Direct Absolute Point
RTG                        ;: Round To Grid
ENDF                       ;: END Function definition
#ARG_COUNT=2:
#RET_COUNT=0: 
#------------------
    f_push      1          ;#--- PUSHB_1    1          ;: PUSH Bytes
FDEF &_1        ;1: Function DEFinition
DUP             &_arg_1    ;: DUPlicate top stack element
MDRP[rp0,min,white] &_DUP_1    ;&_DUP_1 &_DUP_2: Move Direct Relative Point
    f_push      12         ;#--- PUSHB_1    12         ;&_DUP_2: PUSH Bytes
CALL            &_12 &_DUP_2 ;12 &_DUP_2: CALL function
ENDF                       ;: END Function definition
#ARG_COUNT=1:
#RET_COUNT=0: 
#------------------
    f_push      2          ;#--- PUSHB_1    2          ;: PUSH Bytes
FDEF &_2        ;2: Function DEFinition
MPPEM                      ;: Measure Pixels Per EM
GT              &_MPPEM_1 &_arg_1 ;&_MPPEM_1: Greater Than
IF              &_GT_1     ;&_GT_1: IF test
RCVT            &_arg_2    ;: Read Control Value Table entry
SWAP            &_RCVT_1 &_arg_3 ;&_RCVT_1: SWAP the top two elements on the stack
EIF                        ;&_SWAP_1 &_SWAP_2: End IF
POP             &_SWAP_1   ;&_SWAP_1 &_SWAP_2: POP top stack element
ENDF                       ;&_SWAP_2: END Function definition
#ARG_COUNT=3:
#RET_COUNT=1: &_SWAP_2
#RET_STACK: &_SWAP_2
#------------------
    f_push      3          ;#--- PUSHB_1    3          ;: PUSH Bytes
FDEF &_3        ;3: Function DEFinition
ROUND[Black]    &_arg_1    ;: ROUND value
RTG                        ;&_ROUND_1: Round To Grid
DUP             &_ROUND_1  ;&_ROUND_1: DUPlicate top stack element
    f_push      64         ;#--- PUSHB_1    64         ;&_DUP_1 &_DUP_2: PUSH Bytes
LT              &_64 &_DUP_1 ;64 &_DUP_1 &_DUP_2: Less Than
IF              &_LT_1     ;&_LT_1 &_DUP_2: IF test
POP             &_DUP_2    ;&_DUP_2: POP top stack element
    f_push      64         ;#--- PUSHB_1    64         ;: PUSH Bytes
EIF                        ;64: End IF
ENDF                       ;64: END Function definition
#ARG_COUNT=1:
#RET_COUNT=1: 64
#RET_STACK: 64
#------------------
    f_push      4          ;#--- PUSHB_1    4          ;: PUSH Bytes
FDEF &_4        ;4: Function DEFinition
    f_push      6          ;#--- PUSHB_1    6          ;: PUSH Bytes
CALL            &_6        ;6: CALL function
IF              &_f6_retval_1 ;&_f6_retval_1: IF test
POP             &_arg_1    ;: POP top stack element
SWAP            &_arg_2 &_arg_3 ;: SWAP the top two elements on the stack
POP             &_SWAP_1   ;&_SWAP_1 &_SWAP_2: POP top stack element
ROFF                       ;&_SWAP_2: Round OFF
IF              &_SWAP_2   ;&_SWAP_2: IF test
MDRP[rp0,min,rnd,black] &_arg_4    ;: Move Direct Relative Point
ELSE                       ;: ELSE clause
MDRP[min,rnd,black] &_arg_4    ;: Move Direct Relative Point
EIF                        ;  : End IF
ELSE                       ;: ELSE clause
MPPEM                      ;: Measure Pixels Per EM
GT              &_MPPEM_1 &_arg_1 ;&_MPPEM_1: Greater Than
IF              &_GT_1     ;&_GT_1: IF test
IF              &_arg_2    ; : IF test
MIRP[rp0,min,rnd,black] &_arg_3 &_arg_4 ;: Move Indirect Relative Point
ELSE                       ;: ELSE clause
MIRP[min,rnd,black] &_arg_3 &_arg_4 ;: Move Indirect Relative Point
EIF                        ;  : End IF
ELSE                       ;: ELSE clause
SWAP            &_arg_2 &_arg_3 ;: SWAP the top two elements on the stack
POP             &_SWAP_1   ;&_SWAP_1 &_SWAP_2: POP top stack element
    f_push      5          ;#--- PUSHB_1    5          ;&_SWAP_2: PUSH Bytes
CALL            &_5        ;5 &_SWAP_2: CALL function
IF              &_f5_retval_1 ;&_f5_retval_1 &_SWAP_2: IF test
    f_push      70         ;#--- PUSHB_1    70         ;&_SWAP_2: PUSH Bytes
SROUND          &_70       ;70 &_SWAP_2: Super ROUND
EIF                        ;&_SWAP_2: End IF
IF              &_SWAP_2   ;&_SWAP_2: IF test
MDRP[rp0,min,rnd,black] &_arg_4    ;: Move Direct Relative Point
ELSE                       ;: ELSE clause
MDRP[min,rnd,black] &_arg_4    ;: Move Direct Relative Point
EIF                        ;  : End IF
EIF                        ;  : End IF
EIF                        ;  : End IF
RTG                        ;: Round To Grid
ENDF                       ;: END Function definition
#ARG_COUNT=4:
#RET_COUNT=0: 
#------------------
    f_push      5          ;#--- PUSHB_1    5          ;: PUSH Bytes
FDEF &_5        ;5: Function DEFinition
GFV                        ;: Get Freedom Vector
NOT             &_GFV_1    ;&_GFV_1 &_GFV_2: logical NOT
AND             &_NOT_1 &_GFV_2 ;&_NOT_1 &_GFV_2: logical AND
ENDF                       ;&_AND_1: END Function definition
#ARG_COUNT=0:
#RET_COUNT=1: &_AND_1
#RET_STACK: &_AND_1
#------------------
    f_push      6          ;#--- PUSHB_1    6          ;: PUSH Bytes
FDEF &_6        ;6: Function DEFinition
    f_push      1 34       ;#--- PUSHB_2    34 1       ;: PUSH Bytes
GETINFO         &_1        ;1 34: GET INFOrmation
LT              &_GETINFO_1 &_34 ;&_GETINFO_1 34: Less Than
IF              &_LT_1     ;&_LT_1: IF test
    f_push      32         ;#--- PUSHB_1    32         ;: PUSH Bytes
GETINFO         &_32       ;32: GET INFOrmation
NOT             &_GETINFO_1 ;&_GETINFO_1: logical NOT
NOT             &_NOT_1    ;&_NOT_1: logical NOT
ELSE                       ;&_NOT_1: ELSE clause
    f_push      0          ;#--- PUSHB_1    0          ;&_NOT_1: PUSH Bytes
EIF                        ;0 &_NOT_1: End IF
ENDF                       ;&_NOT_1: END Function definition
#ARG_COUNT=0:
#RET_COUNT=1: &_NOT_1
#RET_STACK: &_NOT_1
#------------------
    f_push      7          ;#--- PUSHB_1    7          ;: PUSH Bytes
FDEF &_7        ;7: Function DEFinition
    f_push      1 36       ;#--- PUSHB_2    36 1       ;: PUSH Bytes
GETINFO         &_1        ;1 36: GET INFOrmation
LT              &_GETINFO_1 &_36 ;&_GETINFO_1 36: Less Than
IF              &_LT_1     ;&_LT_1: IF test
    f_push      64         ;#--- PUSHB_1    64         ;: PUSH Bytes
GETINFO         &_64       ;64: GET INFOrmation
NOT             &_GETINFO_1 ;&_GETINFO_1: logical NOT
NOT             &_NOT_1    ;&_NOT_1: logical NOT
ELSE                       ;&_NOT_1: ELSE clause
    f_push      0          ;#--- PUSHB_1    0          ;&_NOT_1: PUSH Bytes
EIF                        ;0 &_NOT_1: End IF
ENDF                       ;&_NOT_1: END Function definition
#ARG_COUNT=0:
#RET_COUNT=1: &_NOT_1
#RET_STACK: &_NOT_1
#------------------
    f_push      8          ;#--- PUSHB_1    8          ;: PUSH Bytes
FDEF &_8        ;8: Function DEFinition
SRP2            &_arg_1    ;: Set Reference Point 2
SRP1            &_arg_2    ;: Set Reference Point 1
DUP             &_arg_3    ;: DUPlicate top stack element
IP              &_DUP_1    ;&_DUP_1 &_DUP_2: Interpolate Point
MDAP[rnd]       &_DUP_2    ;&_DUP_2: Move Direct Absolute Point
ENDF                       ;: END Function definition
#ARG_COUNT=3:
#RET_COUNT=0: 
#------------------
    f_push      9          ;#--- PUSHB_1    9          ;: PUSH Bytes
FDEF &_9        ;9: Function DEFinition
DUP             &_arg_1    ;: DUPlicate top stack element
RDTG                       ;&_DUP_1 &_DUP_2: Round Down To Grid
    f_push      6          ;#--- PUSHB_1    6          ;&_DUP_1 &_DUP_2: PUSH Bytes
CALL            &_6        ;6 &_DUP_1 &_DUP_2: CALL function
IF              &_f6_retval_1 ;&_f6_retval_1 &_DUP_1 &_DUP_2: IF test
MDRP[rnd,grey]  &_DUP_1    ;&_DUP_1 &_DUP_2: Move Direct Relative Point
ELSE                       ;&_DUP_2: ELSE clause
MDRP[min,rnd,black] &_DUP_2    ;&_DUP_2: Move Direct Relative Point
EIF                        ;  : End IF
DUP             &_DUP_2    ;&_DUP_2: DUPlicate top stack element
    f_push      3          ;#--- PUSHB_1    3          ;&_DUP_1 &_DUP_2: PUSH Bytes
CINDEX          &_3        ;3 &_DUP_1 &_DUP_2: Copy the INDEXed element to the top of the stack
MD[grid]        &_CINDEX_1 &_DUP_1 ;&_CINDEX_1 &_DUP_1 &_DUP_2: Measure Distance
SWAP            &_MD_1 &_DUP_2 ;&_MD_1 &_DUP_2: SWAP the top two elements on the stack
DUP             &_SWAP_1   ;&_SWAP_1 &_SWAP_2: DUPlicate top stack element
    f_push      4          ;#--- PUSHB_1    4          ;&_DUP_1 &_DUP_2 &_SWAP_2: PUSH Bytes
MINDEX          &_4        ;4 &_DUP_1 &_DUP_2: Move the INDEXed element to the top of the stack
MD[orig]        &_MINDEX_1 &_DUP_1 ;&_MINDEX_1 &_DUP_1 &_DUP_2: Measure Distance
    f_push      0          ;#--- PUSHB_1    0          ;&_MD_1 &_DUP_2 &_SWAP_2: PUSH Bytes
LT              &_0 &_MD_1 ;0 &_MD_1 &_DUP_2: Less Than
IF              &_LT_1     ;&_LT_1 &_DUP_2 &_SWAP_2: IF test
ROLL            &_DUP_2 &_SWAP_2 &_arg_2 ;&_DUP_2 &_SWAP_2: ROLL the top three stack elements
NEG             &_ROLL_1   ;&_ROLL_1 &_ROLL_2 &_ROLL_3: NEGate
ROLL            &_NEG_1 &_ROLL_2 &_ROLL_3 ;&_NEG_1 &_ROLL_2 &_ROLL_3: ROLL the top three stack elements
SUB             &_ROLL_1 &_ROLL_2 ;&_ROLL_1 &_ROLL_2 &_ROLL_3: SUBtract
DUP             &_SUB_1    ;&_SUB_1 &_ROLL_3: DUPlicate top stack element
    f_push      0          ;#--- PUSHB_1    0          ;&_DUP_1 &_DUP_2 &_ROLL_3: PUSH Bytes
LT              &_0 &_DUP_1 ;0 &_DUP_1 &_DUP_2: Less Than
IF              &_LT_1     ;&_LT_1 &_DUP_2 &_ROLL_3: IF test
SHPIX           &_DUP_2 &_ROLL_3 ;&_DUP_2 &_ROLL_3: SHift point by a PIXel amount
ELSE                       ;: ELSE clause
POP             &_arg_3    ;: POP top stack element
POP             &_arg_4    ;: POP top stack element
EIF                        ;  : End IF
ELSE                       ;: ELSE clause
ROLL            &_arg_2 &_arg_3 &_arg_4 ;: ROLL the top three stack elements
ROLL            &_ROLL_1 &_ROLL_2 &_ROLL_3 ;&_ROLL_1 &_ROLL_2 &_ROLL_3: ROLL the top three stack elements
SUB             &_ROLL_1 &_ROLL_2 ;&_ROLL_1 &_ROLL_2 &_ROLL_3: SUBtract
DUP             &_SUB_1    ;&_SUB_1 &_ROLL_3: DUPlicate top stack element
    f_push      0          ;#--- PUSHB_1    0          ;&_DUP_1 &_DUP_2 &_ROLL_3: PUSH Bytes
GT              &_0 &_DUP_1 ;0 &_DUP_1 &_DUP_2: Greater Than
IF              &_GT_1     ;&_GT_1 &_DUP_2 &_ROLL_3: IF test
SHPIX           &_DUP_2 &_ROLL_3 ;&_DUP_2 &_ROLL_3: SHift point by a PIXel amount
ELSE                       ;: ELSE clause
POP             &_arg_5    ;: POP top stack element
POP             &_arg_6    ;: POP top stack element
EIF                        ;  : End IF
EIF                        ;  : End IF
RTG                        ;: Round To Grid
ENDF                       ;: END Function definition
#ARG_COUNT=2:
#RET_COUNT=0: 
#------------------
    f_push      10         ;#--- PUSHB_1    10         ;: PUSH Bytes
FDEF &_10       ;10: Function DEFinition
    f_push      6          ;#--- PUSHB_1    6          ;: PUSH Bytes
CALL            &_6        ;6: CALL function
IF              &_f6_retval_1 ;&_f6_retval_1: IF test
POP             &_arg_1    ;: POP top stack element
SRP0            &_arg_2    ;: Set Reference Point 0
ELSE                       ;: ELSE clause
SRP0            &_arg_1    ;: Set Reference Point 0
POP             &_arg_2    ;: POP top stack element
EIF                        ;  : End IF
ENDF                       ;: END Function definition
#ARG_COUNT=2:
#RET_COUNT=0: 
#------------------
    f_push      11         ;#--- PUSHB_1    11         ;: PUSH Bytes
FDEF &_11       ;11: Function DEFinition
DUP             &_arg_1    ;: DUPlicate top stack element
MDRP[rp0,white] &_DUP_1    ;&_DUP_1 &_DUP_2: Move Direct Relative Point
    f_push      12         ;#--- PUSHB_1    12         ;&_DUP_2: PUSH Bytes
CALL            &_12 &_DUP_2 ;12 &_DUP_2: CALL function
ENDF                       ;: END Function definition
#ARG_COUNT=1:
#RET_COUNT=0: 
#------------------
    f_push      12         ;#--- PUSHB_1    12         ;: PUSH Bytes
FDEF &_12       ;12: Function DEFinition
DUP             &_arg_1    ;: DUPlicate top stack element
MDAP[rnd]       &_DUP_1    ;&_DUP_1 &_DUP_2: Move Direct Absolute Point
    f_push      7          ;#--- PUSHB_1    7          ;&_DUP_2: PUSH Bytes
CALL            &_7        ;7 &_DUP_2: CALL function
NOT             &_f7_retval_1 ;&_f7_retval_1 &_DUP_2: logical NOT
IF              &_NOT_1    ;&_NOT_1 &_DUP_2: IF test
DUP             &_DUP_2    ;&_DUP_2: DUPlicate top stack element
DUP             &_DUP_1    ;&_DUP_1 &_DUP_2: DUPlicate top stack element
GC[orig]        &_DUP_1    ;&_DUP_1 &_DUP_2 &_DUP_2: Get Coordinate projected onto the projection vector
SWAP            &_GC_1 &_DUP_2 ;&_GC_1 &_DUP_2 &_DUP_2: SWAP the top two elements on the stack
GC[cur]         &_SWAP_1   ;&_SWAP_1 &_SWAP_2 &_DUP_2: Get Coordinate projected onto the projection vector
SUB             &_GC_1 &_SWAP_2 ;&_GC_1 &_SWAP_2 &_DUP_2: SUBtract
ROUND[White]    &_SUB_1    ;&_SUB_1 &_DUP_2: ROUND value
DUP             &_ROUND_1  ;&_ROUND_1 &_DUP_2: DUPlicate top stack element
IF              &_DUP_1    ;&_DUP_1 &_DUP_2 &_DUP_2: IF test
DUP             &_DUP_2    ;&_DUP_2 &_DUP_2: DUPlicate top stack element
ABS             &_DUP_1    ;&_DUP_1 &_DUP_2 &_DUP_2: ABSolute value
DIV             &_ABS_1 &_DUP_2 ;&_ABS_1 &_DUP_2 &_DUP_2: DIVide
SHPIX           &_DIV_1 &_DUP_2 ;&_DIV_1 &_DUP_2: SHift point by a PIXel amount
ELSE                       ;: ELSE clause
POP             &_arg_2    ;: POP top stack element
POP             &_arg_3    ;: POP top stack element
EIF                        ;  : End IF
ELSE                       ;: ELSE clause
POP             &_arg_2    ;: POP top stack element
EIF                        ;  : End IF
ENDF                       ;: END Function definition
#ARG_COUNT=1:
#RET_COUNT=0: 
#------------------
    f_push      13         ;#--- PUSHB_1    13         ;: PUSH Bytes
FDEF &_13       ;13: Function DEFinition
SRP2            &_arg_1    ;: Set Reference Point 2
SRP1            &_arg_2    ;: Set Reference Point 1
DUP             &_arg_3    ;: DUPlicate top stack element
DUP             &_DUP_1    ;&_DUP_1 &_DUP_2: DUPlicate top stack element
IP              &_DUP_1    ;&_DUP_1 &_DUP_2 &_DUP_2: Interpolate Point
MDAP[rnd]       &_DUP_2    ;&_DUP_2 &_DUP_2: Move Direct Absolute Point
DUP             &_DUP_2    ;&_DUP_2: DUPlicate top stack element
ROLL            &_DUP_1 &_DUP_2 &_arg_4 ;&_DUP_1 &_DUP_2: ROLL the top three stack elements
DUP             &_ROLL_1   ;&_ROLL_1 &_ROLL_2 &_ROLL_3: DUPlicate top stack element
GC[orig]        &_DUP_1    ;&_DUP_1 &_DUP_2 &_ROLL_2: Get Coordinate projected onto the projection vector
ROLL            &_GC_1 &_DUP_2 &_ROLL_2 ;&_GC_1 &_DUP_2 &_ROLL_2: ROLL the top three stack elements
GC[cur]         &_ROLL_1   ;&_ROLL_1 &_ROLL_2 &_ROLL_3: Get Coordinate projected onto the projection vector
SUB             &_GC_1 &_ROLL_2 ;&_GC_1 &_ROLL_2 &_ROLL_3: SUBtract
SWAP            &_SUB_1 &_ROLL_3 ;&_SUB_1 &_ROLL_3 &_ROLL_3: SWAP the top two elements on the stack
ROLL            &_SWAP_1 &_SWAP_2 &_ROLL_3 ;&_SWAP_1 &_SWAP_2 &_ROLL_3: ROLL the top three stack elements
DUP             &_ROLL_1   ;&_ROLL_1 &_ROLL_2 &_ROLL_3: DUPlicate top stack element
ROLL            &_DUP_1 &_DUP_2 &_ROLL_2 ;&_DUP_1 &_DUP_2 &_ROLL_2: ROLL the top three stack elements
SWAP            &_ROLL_1 &_ROLL_2 ;&_ROLL_1 &_ROLL_2 &_ROLL_3: SWAP the top two elements on the stack
MD[orig]        &_SWAP_1 &_SWAP_2 ;&_SWAP_1 &_SWAP_2 &_ROLL_3: Measure Distance
    f_push      0          ;#--- PUSHB_1    0          ;&_MD_1 &_ROLL_3 &_ROLL_3: PUSH Bytes
LT              &_0 &_MD_1 ;0 &_MD_1 &_ROLL_3: Less Than
IF              &_LT_1     ;&_LT_1 &_ROLL_3 &_ROLL_3: IF test
SWAP            &_ROLL_3 &_ROLL_3 ;&_ROLL_3 &_ROLL_3: SWAP the top two elements on the stack
    f_push      0          ;#--- PUSHB_1    0          ;&_SWAP_1 &_SWAP_2: PUSH Bytes
GT              &_0 &_SWAP_1 ;0 &_SWAP_1 &_SWAP_2: Greater Than
IF              &_GT_1     ;&_GT_1 &_SWAP_2: IF test
    f_push      64         ;#--- PUSHB_1    64         ;&_SWAP_2: PUSH Bytes
SHPIX           &_64 &_SWAP_2 ;64 &_SWAP_2: SHift point by a PIXel amount
ELSE                       ;: ELSE clause
POP             &_arg_5    ;: POP top stack element
EIF                        ;  : End IF
ELSE                       ;: ELSE clause
SWAP            &_arg_5 &_arg_6 ;: SWAP the top two elements on the stack
    f_push      0          ;#--- PUSHB_1    0          ;&_SWAP_1 &_SWAP_2: PUSH Bytes
LT              &_0 &_SWAP_1 ;0 &_SWAP_1 &_SWAP_2: Less Than
IF              &_LT_1     ;&_LT_1 &_SWAP_2: IF test
    f_push      64         ;#--- PUSHB_1    64         ;&_SWAP_2: PUSH Bytes
NEG             &_64       ;64 &_SWAP_2: NEGate
SHPIX           &_NEG_1 &_SWAP_2 ;&_NEG_1 &_SWAP_2: SHift point by a PIXel amount
ELSE                       ;: ELSE clause
POP             &_arg_7    ;: POP top stack element
EIF                        ;  : End IF
EIF                        ;  : End IF
ENDF                       ;: END Function definition
#ARG_COUNT=4:
#RET_COUNT=0: 
#------------------
    f_push      14         ;#--- PUSHB_1    14         ;: PUSH Bytes
FDEF &_14       ;14: Function DEFinition
    f_push      6          ;#--- PUSHB_1    6          ;: PUSH Bytes
CALL            &_6        ;6: CALL function
IF              &_f6_retval_1 ;&_f6_retval_1: IF test
RTDG                       ;: Round To Double Grid
MDRP[rp0,rnd,white] &_arg_1    ;: Move Direct Relative Point
RTG                        ;: Round To Grid
POP             &_arg_2    ;: POP top stack element
POP             &_arg_3    ;: POP top stack element
ELSE                       ;: ELSE clause
DUP             &_arg_1    ;: DUPlicate top stack element
MDRP[rp0,rnd,white] &_DUP_1    ;&_DUP_1 &_DUP_2: Move Direct Relative Point
ROLL            &_DUP_2 &_arg_2 &_arg_3 ;&_DUP_2: ROLL the top three stack elements
MPPEM                      ;&_ROLL_1 &_ROLL_2 &_ROLL_3: Measure Pixels Per EM
GT              &_MPPEM_1 &_ROLL_1 ;&_MPPEM_1 &_ROLL_1 &_ROLL_2: Greater Than
IF              &_GT_1     ;&_GT_1 &_ROLL_2 &_ROLL_3: IF test
DUP             &_ROLL_2   ;&_ROLL_2 &_ROLL_3: DUPlicate top stack element
ROLL            &_DUP_1 &_DUP_2 &_ROLL_3 ;&_DUP_1 &_DUP_2 &_ROLL_3: ROLL the top three stack elements
SWAP            &_ROLL_1 &_ROLL_2 ;&_ROLL_1 &_ROLL_2 &_ROLL_3: SWAP the top two elements on the stack
MD[grid]        &_SWAP_1 &_SWAP_2 ;&_SWAP_1 &_SWAP_2 &_ROLL_3: Measure Distance
DUP             &_MD_1     ;&_MD_1 &_ROLL_3: DUPlicate top stack element
    f_push      0          ;#--- PUSHB_1    0          ;&_DUP_1 &_DUP_2 &_ROLL_3: PUSH Bytes
NEQ             &_0 &_DUP_1 ;0 &_DUP_1 &_DUP_2: Not EQual
IF              &_NEQ_1    ;&_NEQ_1 &_DUP_2 &_ROLL_3: IF test
SHPIX           &_DUP_2 &_ROLL_3 ;&_DUP_2 &_ROLL_3: SHift point by a PIXel amount
ELSE                       ;: ELSE clause
POP             &_arg_4    ;: POP top stack element
POP             &_arg_5    ;: POP top stack element
EIF                        ;  : End IF
ELSE                       ;: ELSE clause
POP             &_arg_4    ;: POP top stack element
POP             &_arg_5    ;: POP top stack element
EIF                        ;  : End IF
EIF                        ;  : End IF
ENDF                       ;: END Function definition
#ARG_COUNT=3:
#RET_COUNT=0: 
#------------------
    f_push      15         ;#--- PUSHB_1    15         ;: PUSH Bytes
FDEF &_15       ;15: Function DEFinition
SWAP            &_arg_1 &_arg_2 ;: SWAP the top two elements on the stack
DUP             &_SWAP_1   ;&_SWAP_1 &_SWAP_2: DUPlicate top stack element
MDRP[rp0,rnd,white] &_DUP_1    ;&_DUP_1 &_DUP_2 &_SWAP_2: Move Direct Relative Point
DUP             &_DUP_2    ;&_DUP_2 &_SWAP_2: DUPlicate top stack element
MDAP[rnd]       &_DUP_1    ;&_DUP_1 &_DUP_2 &_SWAP_2: Move Direct Absolute Point
    f_push      7          ;#--- PUSHB_1    7          ;&_DUP_2 &_SWAP_2: PUSH Bytes
CALL            &_7        ;7 &_DUP_2 &_SWAP_2: CALL function
NOT             &_f7_retval_1 ;&_f7_retval_1 &_DUP_2 &_SWAP_2: logical NOT
IF              &_NOT_1    ;&_NOT_1 &_DUP_2 &_SWAP_2: IF test
SWAP            &_DUP_2 &_SWAP_2 ;&_DUP_2 &_SWAP_2: SWAP the top two elements on the stack
DUP             &_SWAP_1   ;&_SWAP_1 &_SWAP_2: DUPlicate top stack element
IF              &_DUP_1    ;&_DUP_1 &_DUP_2 &_SWAP_2: IF test
MPPEM                      ;&_DUP_2 &_SWAP_2: Measure Pixels Per EM
GTEQ            &_MPPEM_1 &_DUP_2 ;&_MPPEM_1 &_DUP_2 &_SWAP_2: Greater Than or EQual
ELSE                       ;&_GTEQ_1 &_SWAP_2: ELSE clause
POP             &_GTEQ_1   ;&_GTEQ_1 &_SWAP_2: POP top stack element
    f_push      1          ;#--- PUSHB_1    1          ;&_SWAP_2: PUSH Bytes
EIF                        ;1 &_SWAP_2: End IF
IF              &_GTEQ_1   ;&_GTEQ_1 &_SWAP_2: IF test
ROLL            &_SWAP_2 &_arg_3 &_arg_4 ;&_SWAP_2: ROLL the top three stack elements
    f_push      4          ;#--- PUSHB_1    4          ;&_ROLL_1 &_ROLL_2 &_ROLL_3: PUSH Bytes
MINDEX          &_4        ;4 &_ROLL_1 &_ROLL_2: Move the INDEXed element to the top of the stack
MD[grid]        &_MINDEX_1 &_ROLL_1 ;&_MINDEX_1 &_ROLL_1 &_ROLL_2: Measure Distance
SWAP            &_MD_1 &_ROLL_2 ;&_MD_1 &_ROLL_2 &_ROLL_3: SWAP the top two elements on the stack
ROLL            &_SWAP_1 &_SWAP_2 &_ROLL_3 ;&_SWAP_1 &_SWAP_2 &_ROLL_3: ROLL the top three stack elements
SWAP            &_ROLL_1 &_ROLL_2 ;&_ROLL_1 &_ROLL_2 &_ROLL_3: SWAP the top two elements on the stack
DUP             &_SWAP_1   ;&_SWAP_1 &_SWAP_2 &_ROLL_3: DUPlicate top stack element
ROLL            &_DUP_1 &_DUP_2 &_SWAP_2 ;&_DUP_1 &_DUP_2 &_SWAP_2: ROLL the top three stack elements
MD[grid]        &_ROLL_1 &_ROLL_2 ;&_ROLL_1 &_ROLL_2 &_ROLL_3: Measure Distance
ROLL            &_MD_1 &_ROLL_3 &_ROLL_3 ;&_MD_1 &_ROLL_3 &_ROLL_3: ROLL the top three stack elements
SWAP            &_ROLL_1 &_ROLL_2 ;&_ROLL_1 &_ROLL_2 &_ROLL_3: SWAP the top two elements on the stack
SUB             &_SWAP_1 &_SWAP_2 ;&_SWAP_1 &_SWAP_2 &_ROLL_3: SUBtract
SHPIX           &_SUB_1 &_ROLL_3 ;&_SUB_1 &_ROLL_3: SHift point by a PIXel amount
ELSE                       ;: ELSE clause
POP             &_arg_3    ;: POP top stack element
POP             &_arg_4    ;: POP top stack element
POP             &_arg_5    ;: POP top stack element
POP             &_arg_6    ;: POP top stack element
EIF                        ;  : End IF
ELSE                       ;: ELSE clause
POP             &_1        ;1 &_SWAP_2: POP top stack element
POP             &_SWAP_2   ;&_SWAP_2: POP top stack element
POP             &_arg_3    ;: POP top stack element
POP             &_arg_4    ;: POP top stack element
POP             &_arg_5    ;: POP top stack element
EIF                        ;  : End IF
ENDF                       ;: END Function definition
#ARG_COUNT=4:
#RET_COUNT=0: 
#------------------
    f_push      16         ;#--- PUSHB_1    16         ;: PUSH Bytes
FDEF &_16       ;16: Function DEFinition
DUP             &_arg_1    ;: DUPlicate top stack element
MDRP[rp0,min,white] &_DUP_1    ;&_DUP_1 &_DUP_2: Move Direct Relative Point
    f_push      18         ;#--- PUSHB_1    18         ;&_DUP_2: PUSH Bytes
CALL            &_18 &_DUP_2 &_arg_2 ;18 &_DUP_2: CALL function
ENDF                       ;: END Function definition
#ARG_COUNT=2:
#RET_COUNT=0: 
#------------------
    f_push      17         ;#--- PUSHB_1    17         ;: PUSH Bytes
FDEF &_17       ;17: Function DEFinition
DUP             &_arg_1    ;: DUPlicate top stack element
MDRP[rp0,white] &_DUP_1    ;&_DUP_1 &_DUP_2: Move Direct Relative Point
    f_push      18         ;#--- PUSHB_1    18         ;&_DUP_2: PUSH Bytes
CALL            &_18 &_DUP_2 &_arg_2 ;18 &_DUP_2: CALL function
ENDF                       ;: END Function definition
#ARG_COUNT=2:
#RET_COUNT=0: 
#------------------
    f_push      18         ;#--- PUSHB_1    18         ;: PUSH Bytes
FDEF &_18       ;18: Function DEFinition
DUP             &_arg_1    ;: DUPlicate top stack element
MDAP[rnd]       &_DUP_1    ;&_DUP_1 &_DUP_2: Move Direct Absolute Point
    f_push      7          ;#--- PUSHB_1    7          ;&_DUP_2: PUSH Bytes
CALL            &_7        ;7 &_DUP_2: CALL function
NOT             &_f7_retval_1 ;&_f7_retval_1 &_DUP_2: logical NOT
IF              &_NOT_1    ;&_NOT_1 &_DUP_2: IF test
DUP             &_DUP_2    ;&_DUP_2: DUPlicate top stack element
DUP             &_DUP_1    ;&_DUP_1 &_DUP_2: DUPlicate top stack element
GC[orig]        &_DUP_1    ;&_DUP_1 &_DUP_2 &_DUP_2: Get Coordinate projected onto the projection vector
SWAP            &_GC_1 &_DUP_2 ;&_GC_1 &_DUP_2 &_DUP_2: SWAP the top two elements on the stack
GC[cur]         &_SWAP_1   ;&_SWAP_1 &_SWAP_2 &_DUP_2: Get Coordinate projected onto the projection vector
SUB             &_GC_1 &_SWAP_2 ;&_GC_1 &_SWAP_2 &_DUP_2: SUBtract
ROUND[White]    &_SUB_1    ;&_SUB_1 &_DUP_2: ROUND value
ROLL            &_ROUND_1 &_DUP_2 &_arg_2 ;&_ROUND_1 &_DUP_2: ROLL the top three stack elements
DUP             &_ROLL_1   ;&_ROLL_1 &_ROLL_2 &_ROLL_3: DUPlicate top stack element
GC[orig]        &_DUP_1    ;&_DUP_1 &_DUP_2 &_ROLL_2: Get Coordinate projected onto the projection vector
SWAP            &_GC_1 &_DUP_2 ;&_GC_1 &_DUP_2 &_ROLL_2: SWAP the top two elements on the stack
GC[cur]         &_SWAP_1   ;&_SWAP_1 &_SWAP_2 &_ROLL_2: Get Coordinate projected onto the projection vector
SWAP            &_GC_1 &_SWAP_2 ;&_GC_1 &_SWAP_2 &_ROLL_2: SWAP the top two elements on the stack
SUB             &_SWAP_1 &_SWAP_2 ;&_SWAP_1 &_SWAP_2 &_ROLL_2: SUBtract
ROUND[White]    &_SUB_1    ;&_SUB_1 &_ROLL_2 &_ROLL_3: ROUND value
ADD             &_ROUND_1 &_ROLL_2 ;&_ROUND_1 &_ROLL_2 &_ROLL_3: ADD
DUP             &_ADD_1    ;&_ADD_1 &_ROLL_3: DUPlicate top stack element
IF              &_DUP_1    ;&_DUP_1 &_DUP_2 &_ROLL_3: IF test
DUP             &_DUP_2    ;&_DUP_2 &_ROLL_3: DUPlicate top stack element
ABS             &_DUP_1    ;&_DUP_1 &_DUP_2 &_ROLL_3: ABSolute value
DIV             &_ABS_1 &_DUP_2 ;&_ABS_1 &_DUP_2 &_ROLL_3: DIVide
SHPIX           &_DIV_1 &_ROLL_3 ;&_DIV_1 &_ROLL_3: SHift point by a PIXel amount
ELSE                       ;: ELSE clause
POP             &_arg_3    ;: POP top stack element
POP             &_arg_4    ;: POP top stack element
EIF                        ;  : End IF
ELSE                       ;: ELSE clause
POP             &_arg_2    ;: POP top stack element
POP             &_arg_3    ;: POP top stack element
EIF                        ;  : End IF
ENDF                       ;: END Function definition
#ARG_COUNT=2:
#RET_COUNT=0: 
#------------------
    f_push      19         ;#--- PUSHB_1    19         ;: PUSH Bytes
FDEF &_19       ;19: Function DEFinition
DUP             &_arg_1    ;: DUPlicate top stack element
ROLL            &_DUP_1 &_DUP_2 &_arg_2 ;&_DUP_1 &_DUP_2: ROLL the top three stack elements
DUP             &_ROLL_1   ;&_ROLL_1 &_ROLL_2 &_ROLL_3: DUPlicate top stack element
ROLL            &_DUP_1 &_DUP_2 &_ROLL_2 ;&_DUP_1 &_DUP_2 &_ROLL_2: ROLL the top three stack elements
SDPVTL[orthog]  &_ROLL_1 &_ROLL_2 ;&_ROLL_1 &_ROLL_2 &_ROLL_3: Set Dual Projection Vector To Line
DUP             &_ROLL_3   ;&_ROLL_3 &_ROLL_3: DUPlicate top stack element
    f_push      3          ;#--- PUSHB_1    3          ;&_DUP_1 &_DUP_2 &_ROLL_3: PUSH Bytes
CINDEX          &_3        ;3 &_DUP_1 &_DUP_2: Copy the INDEXed element to the top of the stack
MD[orig]        &_CINDEX_1 &_DUP_1 ;&_CINDEX_1 &_DUP_1 &_DUP_2: Measure Distance
ABS             &_MD_1     ;&_MD_1 &_DUP_2 &_ROLL_3: ABSolute value
SWAP            &_ABS_1 &_DUP_2 ;&_ABS_1 &_DUP_2 &_ROLL_3: SWAP the top two elements on the stack
ROLL            &_SWAP_1 &_SWAP_2 &_ROLL_3 ;&_SWAP_1 &_SWAP_2 &_ROLL_3: ROLL the top three stack elements
SPVTL[orthog]   &_ROLL_1 &_ROLL_2 ;&_ROLL_1 &_ROLL_2 &_ROLL_3: Set Projection Vector To Line
    f_push      32         ;#--- PUSHB_1    32         ;&_ROLL_3: PUSH Bytes
LT              &_32 &_ROLL_3 ;32 &_ROLL_3: Less Than
IF              &_LT_1     ;&_LT_1: IF test
ALIGNRP         &_arg_3    ;: ALIGN to Reference Point
ELSE                       ;: ELSE clause
MDRP[grey]      &_arg_3    ;: Move Direct Relative Point
EIF                        ;  : End IF
ENDF                       ;: END Function definition
#ARG_COUNT=3:
#RET_COUNT=0: 
#------------------
    f_push      20         ;#--- PUSHB_1    20         ;: PUSH Bytes
FDEF &_20       ;20: Function DEFinition
    f_push      64 1 64 0  ;#--- PUSHB_4    0 64 1 64  ;: PUSH Bytes
WS              &_64 &_1   ;64 1 64: Write Store
WS              &_64 &_0   ;64 0: Write Store
SVTCA[x-axis]              ;: Set freedom and projection Vectors To Coordinate Axis
MPPEM                      ;: Measure Pixels Per EM
    f_push      4096       ;#--- PUSHW_1    4096       ;&_MPPEM_1: PUSH Words
MUL             &_4096 &_MPPEM_1 ;4096 &_MPPEM_1: MULtiply
SVTCA[y-axis]              ;&_MUL_1: Set freedom and projection Vectors To Coordinate Axis
MPPEM                      ;&_MUL_1: Measure Pixels Per EM
    f_push      4096       ;#--- PUSHW_1    4096       ;&_MPPEM_1 &_MUL_1: PUSH Words
MUL             &_4096 &_MPPEM_1 ;4096 &_MPPEM_1 &_MUL_1: MULtiply
DUP             &_MUL_1    ;&_MUL_1 &_MUL_1: DUPlicate top stack element
ROLL            &_DUP_1 &_DUP_2 &_MUL_1 ;&_DUP_1 &_DUP_2 &_MUL_1: ROLL the top three stack elements
DUP             &_ROLL_1   ;&_ROLL_1 &_ROLL_2 &_ROLL_3: DUPlicate top stack element
ROLL            &_DUP_1 &_DUP_2 &_ROLL_2 ;&_DUP_1 &_DUP_2 &_ROLL_2: ROLL the top three stack elements
NEQ             &_ROLL_1 &_ROLL_2 ;&_ROLL_1 &_ROLL_2 &_ROLL_3: Not EQual
IF              &_NEQ_1    ;&_NEQ_1 &_ROLL_3 &_ROLL_3: IF test
DUP             &_ROLL_3   ;&_ROLL_3 &_ROLL_3: DUPlicate top stack element
ROLL            &_DUP_1 &_DUP_2 &_ROLL_3 ;&_DUP_1 &_DUP_2 &_ROLL_3: ROLL the top three stack elements
DUP             &_ROLL_1   ;&_ROLL_1 &_ROLL_2 &_ROLL_3: DUPlicate top stack element
ROLL            &_DUP_1 &_DUP_2 &_ROLL_2 ;&_DUP_1 &_DUP_2 &_ROLL_2: ROLL the top three stack elements
GT              &_ROLL_1 &_ROLL_2 ;&_ROLL_1 &_ROLL_2 &_ROLL_3: Greater Than
IF              &_GT_1     ;&_GT_1 &_ROLL_3 &_ROLL_3: IF test
SWAP            &_ROLL_3 &_ROLL_3 ;&_ROLL_3 &_ROLL_3: SWAP the top two elements on the stack
DIV             &_SWAP_1 &_SWAP_2 ;&_SWAP_1 &_SWAP_2: DIVide
DUP             &_DIV_1    ;&_DIV_1: DUPlicate top stack element
    f_push      0          ;#--- PUSHB_1    0          ;&_DUP_1 &_DUP_2: PUSH Bytes
SWAP            &_0 &_DUP_1 ;0 &_DUP_1 &_DUP_2: SWAP the top two elements on the stack
WS              &_SWAP_1 &_SWAP_2 ;&_SWAP_1 &_SWAP_2 &_DUP_2: Write Store
ELSE                       ;&_DUP_2: ELSE clause
DIV             &_DUP_2 &_arg_1 ;&_DUP_2: DIVide
DUP             &_DIV_1    ;&_DIV_1: DUPlicate top stack element
    f_push      1          ;#--- PUSHB_1    1          ;&_DUP_1 &_DUP_2: PUSH Bytes
SWAP            &_1 &_DUP_1 ;1 &_DUP_1 &_DUP_2: SWAP the top two elements on the stack
WS              &_SWAP_1 &_SWAP_2 ;&_SWAP_1 &_SWAP_2 &_DUP_2: Write Store
EIF                        ;&_DUP_2: End IF
DUP             &_DUP_2    ;&_DUP_2: DUPlicate top stack element
    f_push      64         ;#--- PUSHB_1    64         ;&_DUP_1 &_DUP_2: PUSH Bytes
GT              &_64 &_DUP_1 ;64 &_DUP_1 &_DUP_2: Greater Than
IF              &_GT_1     ;&_GT_1 &_DUP_2: IF test
    f_push      0 32 0     ;#--- PUSHB_3    0 32 0     ;&_DUP_2: PUSH Bytes
RS              &_0        ;0 32 0: Read Store
MUL             &_RS_1 &_32 ;&_RS_1 32 0: MULtiply
WS              &_MUL_1 &_0 ;&_MUL_1 0 &_DUP_2: Write Store
    f_push      1 32 1     ;#--- PUSHB_3    1 32 1     ;&_DUP_2: PUSH Bytes
RS              &_1        ;1 32 1: Read Store
MUL             &_RS_1 &_32 ;&_RS_1 32 1: MULtiply
WS              &_MUL_1 &_1 ;&_MUL_1 1 &_DUP_2: Write Store
    f_push      32         ;#--- PUSHB_1    32         ;&_DUP_2: PUSH Bytes
MUL             &_32 &_DUP_2 ;32 &_DUP_2: MULtiply
    f_push      25         ;#--- PUSHB_1    25         ;&_MUL_1: PUSH Bytes
NEG             &_25       ;25 &_MUL_1: NEGate
JMPR            &_NEG_1    ;&_NEG_1 &_MUL_1: JuMP Relative
POP             &_MUL_1    ;&_MUL_1: POP top stack element
EIF                        ;  : End IF
ELSE                       ;: ELSE clause
POP             &_arg_1    ;: POP top stack element
POP             &_arg_2    ;: POP top stack element
EIF                        ;  : End IF
ENDF                       ;: END Function definition
#ARG_COUNT=0:
#RET_COUNT=0: 
#------------------
    f_push      21         ;#--- PUSHB_1    21         ;: PUSH Bytes
FDEF &_21       ;21: Function DEFinition
    f_push      1          ;#--- PUSHB_1    1          ;: PUSH Bytes
RS              &_1        ;1: Read Store
MUL             &_RS_1 &_arg_1 ;&_RS_1: MULtiply
SWAP            &_MUL_1 &_arg_2 ;&_MUL_1: SWAP the top two elements on the stack
    f_push      0          ;#--- PUSHB_1    0          ;&_SWAP_1 &_SWAP_2: PUSH Bytes
RS              &_0        ;0 &_SWAP_1 &_SWAP_2: Read Store
MUL             &_RS_1 &_SWAP_1 ;&_RS_1 &_SWAP_1 &_SWAP_2: MULtiply
SWAP            &_MUL_1 &_SWAP_2 ;&_MUL_1 &_SWAP_2: SWAP the top two elements on the stack
ENDF                       ;&_SWAP_1 &_SWAP_2: END Function definition
#ARG_COUNT=2:
#RET_COUNT=2: &_SWAP_2 &_SWAP_1
#RET_STACK: &_SWAP_2 &_SWAP_1
#------------------
FDEF 22
#check distance 
#1.s1,s4 between grid/orig if lt/gt 24/48 then shift left/right s1
#2.s0,s1 between grid/orig if lt/gt 64/42 then shift left/right s1,s3,sx
#ARG:s0 s1 s3 sx
#START                      ;s0 s1 s3 sx
CINDEX  3                   ;s3 s0 s1 s3 sx
CINDEX  3                   ;s1 s3 s0 s1 s3 sx
MD[grid]    &_s1 &_s3       ;mdg s0 s1 s3 sx
CINDEX  4                   ;s3 mdg s0 s1 s3 sx
CINDEX  4                   ;s1 s3 mdg s0 s1 s3 sx
MD[orig]    &_s1 &_s3       ;mdo mdg s0 s1 s3 sx
SUB &_mdo &_mdg             ;sub s0 s1 s3 sx
DUP                         ;sub sub s0 s1 s3 sx
LT  -24 &_sub               ;sub s0 s1 s3 sx
IF  &_lt                    ;sub s0 s1 s3 sx
    CINDEX  3               ;s1 sub s0 s1 s3 sx
    SHPIX -64 &_s1          ;sub s0 s1 s3 sx
EIF
GT  48 &_sub                ;gt s0 s1 s3 sx
IF  &_gt                    ;s0 s1 s3 sx
    CINDEX  2               ;s1 s0 s1 s3 sx
    SHPIX 64 &_s1           ;s0 s1 s3 sx
EIF
#
#START                      ;s0 s1 s3 sx
CINDEX  2                   ;s1 s0 s1 s3 sx
CINDEX  2                   ;s0 s1 s0 s1 s3 sx
MD[grid]    &_s0 &_s1       ;mdg s0 s1 s3 sx
CINDEX  3                   ;s1 mdg s0 s1 s3 sx
MINDEX  3                   ;s0 s1 mdg s1 s3 sx
MD[orig]    &_s0 &_s1       ;mdo mdg s1 s3 sx
SUB     &_mdo &_mdg         ;sub s1 s3 sx
DUP                         ;sub sub s1 s3 sx
GT      42 &_sub            ;gt sub s1 s3 sx
IF      &_gt                ;sub s1 s3 sx
    POP &_sub               ;s1 s3 sx
    SLOOP   3 #F#           ;
    SHPIX   -64 #F#            ;
ELSE                        ;sub s1 s3 sx
    LT  -64 &_sub            ;lt s1 s3 sx
    IF  &_lt                ;s1 s3 sx
        SLOOP   3 #F#       ;
        SHPIX   64 #F#         ;
    ELSE                    ;s1 s3 sx
        POP
        POP
        POP
    EIF
EIF
ENDF
#ARG_COUNT=4:
#RET_COUNT=0:
#------------------
FDEF 23
#test gap(grid) of s4,sx, if < orig or < 48 then move left s3,s4
#ARG:s3 s4 sx
#START:                     ;s3 s4 sx
CINDEX  3                   ;sx s3 s4 sx
CINDEX  3                   ;s4 sx s3 s4 sx
MD[grid]    &_s4 &_sx       ;mdg s3 s4 sx
MINDEX  4                   ;sx mdg s3 s4
CINDEX  4                   ;s4 sx mdg s3 s4
MD[orig]    &_s4 &_sx       ;mdo mdg s3 s4
LT  &_mdo &_mdg             ;lt s3 s4
IF  &_lt                    ;s3 s4
    SHPIX -64 &_s3          ;s4
    SHPIX -64 &_s4          ;
ELSE
    POP
    POP
EIF
ENDF
#ARG_COUNT=3:
#RET_COUNT=0:
#------------------
FDEF 24
#measure ppem, if > 42 then RTDG else RDTG
#ARG:0
MPPEM
GT  41  &_mppem
IF  &_gt
    RTDG
EIF
ENDF
#ARG_COUNT=0:
#RET_COUNT=0:
#------------------
"""

#EXAMPLE OF CVT FUNCTION DEFINED:
#
#def estemw_1(s): = """
#   MIRP[rnd,black]    estemw s
#   f_dstr(s,"ds_estemw")
#   """
#
#def estemw_2(s): = """
#   MIRP[rnd,black]    estemw s
#   f_dstr(s,"ds_estemw",direction="-")
#   """

#----------------------------------------
#DRY HEAD
#ENABLE DRY HEAD FOR BOOK
ds_dryhead = "14+3 15+3 16+3 "
def dh1(*l): #dry head
    d = {}
    for s in l:
        d[s-1] = ds_dryhead
        d[s+1] = swap_dstr(ds_dryhead)
    return f_dstr_dict(d)
#    return f_dstr_dict({
#        s-1: "15+4 16+3 17+3 18+3 ",
#        s+1: "15-4 16-3 17-3 18-3 " })

def dh2(*l): #dry head
    d = {}
    for s in l:
        d[s-1] = swap_dstr(ds_dryhead)
        d[s+1] = ds_dryhead
    return f_dstr_dict(d)
#    return f_dstr_dict({
#        s-1: "15-4 16-3 17-3 18-3 ",
#        s+1: "15+4 16+3 17+3 18+3 " })

def dh11(s): #dry 1 point +
    return f_dstr(s,ds_dryhead)

def dh12(s): #dry 1 point -
    return f_dstr(s,ds_dryhead,direction='-')


#DISABLE DRY HEAD FOR BOLD
#def dh1(*l):
#    return ""
#def dh2(*l):
#    return ""
#def dh11(s):
#    return ""
#def dh12(s):
#    return ""



#----------------------------------------
def dx(s,x):
    return """
SHPIX   %s %s
""" % (x,s)

#================================================
def vbc_base(s,cvt1,li=[]):
    s,adds = gen_alignrp(s)
    return pl(""
        , mirp0rg(cvt1,s)
        , f_ip(li)
        , adds
        )

def tvbc(s,li=[]):  #thai vbase curve
    return vbc_base(s,"tvbase_shoot",li)

def evbc(s,li=[]):  #thai vbase curve
    return vbc_base(s,"evbase_shoot",li)

def tvblu(s,li=[]):
    return pl(""
        , mirprg("tvheight_lu",s)
        , f_ip(li)
        )

def tvblum(s,li=[]):
    return vbc_base(s,"tvheight_lu",li)

def tvtc2(s,li=[]): #thai vtop curve
    return vbc_base(s,"tvheight_shoot",li)

def evtc2(s,li=[]): #vtop curve
    return vbc_base(s,"evheight_shoot",li)

def tvt2(s,li=[]):
    return pl(""
        , mirprg("tvheight",s,"15+8 17+8 22+8 24+8 26+8 29+8 31+8 33+8 35+8 36+8 38+8 40+8 42+8 ")
        , f_ip(li)
        )

def vt2m(s,li=[]):
    return pl(""
        , mirp0rg("vheight",s,ds_vheight)
        , f_ip(li)
        )

def tvtpo(s,li=[]):
    return pl(""
        , mirprg("tvheight_po",s)
        , f_ip(li)
        )

def vtpom(s,li=[]):
    return pl(""
        , mirp0rg("vheight_po",s)
        , f_ip(li)
        )

def tvtsara(s):
    return mdapr(s,"12+8 15+8 ")

def tvtwanayuk(s):
    return mdapr(s,"12+8 15+8 17+8 ")


ds_tvheight_num = "10+8 19+8 21+8 28+8 30+8 32+8 37+8 39+8 41+8 "
def tvtn(s, li=[]):
    return pl(""
        , mirp0rg("tvheight_num",s,ds_tvheight_num)
        , f_ip(li)
        )

def tvtnc(s, li=[]):
    return pl(""
        , mirp0rg("tvheight_num_shoot",s)
        , f_ip(li)
        )

def head_0(s,li,direction="+",ss=-1,l1s=-1,l2s=-1,dia="headdia"):
    exec "ds = ds_%s" % (dia,)
    if direction == "-":
        l1 = li[1]
        l2 = li[0]
        temp = l1s
        l1s = l2s
        l2s = temp
        ds = swap_dstr(ds)
        if dia == "head_sara":
            stem1 = head_sara_stem_2(l1)
            stem2 = head_sara_stem_1(l2)
        else:
            stem1 = headstem_2(l1)
            stem2 = headstem_1(l2)
    else:
        l1 = li[0]
        l2 = li[1]
        if dia == "head_sara":
            stem1 = head_sara_stem_1(l1)
            stem2 = head_sara_stem_2(l2)
        else:
            stem1 = headstem_1(l1)
            stem2 = headstem_2(l2)
    if len(li)>2:
        ip = f_ip(li[2:])
    else:
        ip = ""
    if ss >= 0:
        add_ss = alignrp(ss)
    else:
        add_ss = ""
    if l1s >= 0:
        add_l1s = shprp2(l1s)
    else:
        add_l1s = ""
    if l2s >= 0:
        add_l2s = shprp2(l2s)
    else:
        add_l2s = ""
    return pl(""
        , stem1
        , add_l1s
        , mirp0rg(dia,s,ds)
        , add_ss
        , ip
        , stem2
        , add_l2s
        )

def head1(s,li,ss=-1,l1s=-1,l2s=-1):
    #left to right
    return head_0(s,li,direction="+",ss=ss,l1s=l1s,l2s=l2s)

def head2(s,li,ss=-1,l1s=-1,l2s=-1):
    #right to left
    return head_0(s,li,direction="-",ss=ss,l1s=l1s,l2s=l2s)

def headsara1(s,li,ss=-1,l1s=-1,l2s=-1,dia="head_sara"):
    #left to right
    return head_0(s,li,direction="+",ss=ss,l1s=l1s,l2s=l2s,dia=dia)

def headsara2(s,li,ss=-1,l1s=-1,l2s=-1,dia="head_sara"):
    #right to left
    return head_0(s,li,direction="-",ss=ss,l1s=l1s,l2s=l2s,dia=dia)


def xhead0(s2,s3,direction="+",s2s=-1,s3s=-1):
    add2 = add3 = ""
    if s2s >=0 : add2 = shprp2(s2s)
    if s3s >=0 : add3 = shprp2(s3s)
    return pl(""
        , headstem_1(s2,direction=direction)
        , add2
        , hsph_1(s3,direction=direction)
        , add3
        )


def xhead1(s1,s2,s3,dstr="11+8 12+8 13+8 26+8 27+8 28+8 ",direction="+",s1s=-1,s2s=-1,s3s=-1):
    add1 = ""
    if s1s >=0 : add1 = alignrp(s1s)
    return pl(""
        , mdrp0rg(s1,dstr)
        , add1
        , xhead0(s2,s3,direction,s2s,s3s)
        )

def xhead2(s1,s2,s3,dstr="12-8 13-8 16-8 25-8 26-8 ",direction="-"):
    return xhead1(s1,s2,s3,dstr,direction)


#================================================
def v_notch_ko_kai(s1,s1s,s2):
    return pl(""
        , mdrp0rg(s1,"23+8 ")
        , alignrp(s1s)
        , stem_notch_1(s2)
        , dx(s2,-8)
        )

def v_head_kho_khai(s1,li1, s2, s3,s4, li4, add1=""):
    return pl(""
        , tvtc2(s1,li1)
        , add1
        , tstemt_thin_2(s2)
        , mdrp0rg(s3)
        , head2(s4,li4)
        )

def v_head_kho_khuat(s1,s1s,li1, s2,s2s, s3,s4, s5,s6,li6 , add1=""):
    return pl(""
        , tvtc2(s1, li1)
        , alignrp(s1s)
        , add1
        , tstemt_2(s2)
        , shprp2(s2s)
        , mdrp0mrg(s3,"9-3 10-3 11-3 12-3 17-3 18-3 19-3 20-3 21-3 ")
        , mdrpb(s4)
        , mdrp0rg(s5)
        , mdapr(s5)
        , head2(s6,li6)
        )

def v_top_kho_khwai(s1,li1,s2, s3,s4,li4,add1=""):
    if len(li4) > 3:
        add4 = f_dstr_dict({
            li4[2]:"14+2 15+2 16+2 ",
            li4[3]:"14-4 15-4 16-4 ",
            })
    else:
        add4 = ""
    return pl(""
        , tvtc2(s1,li1)
        , add1
        , tstemtc_thin_2(s2)
        , mdrp0rw(s3)
        , head2(s4,li4)
        , add4
        )

def v_top_kho_khon(s1,s1s,li1, s2,s2s, s3,s4, s5,s6,li6):
    if len(li6) > 3:
        add6 = f_dstr_dict({
            li6[2]:"14+2 15+2 16+2 ",
            li6[3]:"14-4 15-4 16-4 ",
            })
    else:
        add6 = ""
    return pl(""
        , tvtc2(s1,li1)
        , alignrp(s1s)
        , tstemt_2(s2)
        , shprp2(s2s)
        , mdrp0rg(s3,"9-8 10-8 12-3 13-3 14-3 15-3 16-3 17-3 ")
        , tstemt_sara_2(s4)
        , mdrp0mrw(s5)
        , mdapr(s5)
        , head2(s6,li6)
        , add6
        )
        
def v_top_ro_rua(s1,li1, s2, s3,s4,s5,s6):
    return pl(""
        , tvtc2(s1,li1)
        , tstemtc_thin_2(s2)
#        , mdrp0rg(s3,"9-4 10-4 11-4 12+4 13+4 ")
#, mdrp0g(s3)
, mdrp0g(s3,"9+1 10+2 11+2 12+2 13+1 ")
        , tstemt_1(s4)
        , srp0(s1)
        , mdrp0g(s5)
        , tstemt_2(s6)
        )

#================================================
def hs1(s,ds="9-8 "):    #start point #1 forward
    #ko_kai, kho_khwai
    return mdapr(s,ds)

def hs2(s,ds="9-8 14-8 "):    #start point #2 reverse
    #kho_khai, cho_chan
    return mdapr(s,ds)

def hw1(s,li=[],ds="11+8 23+8 26+8 "): 
    #make width #1  forward
    #move from front stem of ko_kai to rear stem
    return pl(""
        , mirp0rg("w_316",s,ds)
        , f_ip(li)
        )

def hw2(s,li=[],ds="11-8 12-8 "): 
    #make width #2  reverse
    return pl(""
        , mirp0rg("w_362",s,ds)
        , f_ip(li)
        )

def hw3(s,li=[],ds="17-8 "): 
    #make width #3 forward, pho_samphao
    return pl(""
        , mirp0rg("w_266",s,ds)
        , f_ip(li)
        )

def hw4(s,li=[],ds="11+8 "): 
    #make width #4 forward
    return pl(""
        , mirp0rg("w_214",s,ds)
        , f_ip(li)
        )

def hw5(s,li=[],ds="9-8 11+8 12+8 15+8 17-8 26+8 33+8 "): 
    #make width #5 forward, tho_thahan
    return pl(""
        , mirp0rg("w_285",s,ds)
        , f_ip(li)
        )

def tg_0(s0,s1,s2,ds=""):  #thai gap
    return pl(""
        , srp0(s0)
        , mdrp0rg(s1,ds)
        , tstemw_1(s2)
        )


def tgf_148(s0,s1,s2):  #thai front gap
    return tg_0(s0,s1,s2,"9-8 10-8 ")

def tgf_112(s0,s1,s2):  #thai front gap
    return tg_0(s0,s1,s2,"9-8 10-8 11-8 ")

def tgf_162(s0,s1,s2):  #thai front gap
    return tg_0(s0,s1,s2,"9-8 10-8 ")


def tgr_112(s0,s1,s2):  #thai rear gap
    return tg_0(s0,s1,s2,"9-8 10-8 17-8 ")

def tgr_140(s0,s1,s2):  #thai rear gap
    return tg_0(s0,s1,s2,"9-8 16+8 ")

def tgr_160(s0,s1,s2):
    return tg_0(s0,s1,s2,"16+8 ")


def hf1(s0,s1,s2,s3,s4,s5,s1s=-1,s2s=-1,s3s=-1,s4s=-1,s5s=-1,dstr1="9-8 10-8 11-8 19+8 ",add1=""):
    #front h for tho_thahan, po_pan, no_nu, etc.
    if s1s >= 0:
        add1 = pl(alignrp(s1s), add1)
    if s2s >= 0:
        add2 = shprp2(s2s)
    else:
        add2 = ""
    add3 = xhead1(s3,s4,s5,s1s=s3s,s2s=s4s,s3s=s5s) 
    return pl(""
        , srp0(s0)
        , mdrp0rw(s1,dstr1)
        , add1
        , tstemw_1(s2)
        , add2
        , add3
        )

def hf_ko_kai(s0, s1,s2, s3,s4, s5,s6):
    return pl(""
        , tgf_162(s0,s1,s2)
#        , mdrp0g(s3,"9+4 10+4 14+4 15+4 16+4 17+4 18+4 ")
, mdrp0g(s3)
        , mdrpg(s4)
        , srp0(s2)
        , mdrpg(s5)
        , add_ip(s3,s2,[s6])
        , dx(s6,-8)
        )


def hf_kho_khai(s0,s1,t1, s2,li):
    return pl(""
        , srp0(s0)
        , mdrp0rw(s1,"15+8 16+8 17+8 18+8 19+8 ")
        , tstemw_1(t1)
        #, head1(s2,li)
        , mirp0rg('headdia',s2,ds_headdia)
        , xhead0(li[1],li[0],direction='-')
        )

def hr_kho_khai(s0,s1,s2,s3,s4,s5,s6,add1="",add6=""):
    return pl(""
        , tgr_160(s0,s1,s2)
        , add1
        , mdrp0rg(s3,"13-8 ")
        , tstemw_1(s4)
        , mdrp0rg(s5,"10+8 11+8 13+8 14+8 15+8 16+8 ")
        , tstemw_1(s6)
        , add6
        )

def hr_cho_chang(s0,s1,s2, t11,t12, s3,s4,s5,s6, i56, s7):
    return hr_kho_khai(s0,s1,s2,s3,s4,s5,s6,
            add1=pl(""
                , mdrp0mrg(t11)
                , tstemw_1(t12)
                , srp0(s1)
                ),
            add6=pl(""
                , f_ip([i56])
                , srp0(s6)
                , mdrpg(s7,"13-4 14-8 15-8 16-8 ")
                )
            )

def hf_kho_khwai(s0, s1,s2, s3,s4, i4, s5,s6,li6,ds5="15-8 16-8 28-8 29-8 "):
    return pl(""
        , tgf_112(s0,s1,s2)
        , mdrp0rg(s3,"10-8 ")
        , tstemw_1(s4)
        , add_ip(s2,s4,[i4])
        , srp0(s1)
        , mdrp0rg(s5,ds5)
        , head1(s6,li6)
        )

def hr_no_nu(s0, s1,s2, s3,s4,li):
    return pl(""
        , srp0(s0)
        , mdrp0rg(s1,"9-8 10-8 11-8 22+8 27+8 ")
        , tstemw_1(s2)
        , mdrp0rg(s3,"14-8 15-8 16-8 20-8 21-8 22-8 25-8 26-8 27-8 30-8 31-8 ")
        , head2(s4,li)
        )

def hf_pho_samphao(s0, s1,s2, s3,s4,s5, s6,s7,s8,s9):
    return pl(""
        , hf1(s0, s1,s2, s3,s4,s5)
        , srp0(s1)
        , mdrp0g(s6)
        , mdrpg(s7)
        , srp0(s2)
        , mdrp0g(s8)
        , mdrpg(s9)
        )

#================================================
def h_edge(s0, s1, s2 ,sx, ds1="", ds2="", dsx="", min2=True):
    s1,add1 = gen_alignrp(s1)
    s2,add2 = gen_alignrp(s2)
    sx,addx = gen_alignrp(sx)
    if add1:    add1 = pl(srp0(s1),add1)
    if add2:    add2 = pl(srp0(s2),add2)
    if addx:    addx = pl(srp0(sx),addx)
    if min2:
        fxx2 = mdrp0mrw
    else:
        fxx2 = mdrprw
    return pl(""
        , mdapr(sx)
        , fxx2(s2)
        , mdrp0rg(s1)
        , 'CALL 22 %s %s %s %s' % (s0,s1,s2,sx,)
        , f_dstr(s1,ds1)
        , add1
        , f_dstr(s2,ds2)
        , add2
        , f_dstr(sx,dsx)
        , addx
        )

def h_main_1(s0, s1,fx12,s2, sx, ds1="",dsx=""):
    s1,add1 = gen_alignrp(s1)
    s2,add2 = gen_alignrp(s2,a=2)
    sx,addx = gen_alignrp(sx)
    if addx:    addx = pl(srp0(sx),addx)
    return pl(""
        , mdapr(sx)
        , mdrp0mw(s2)
        , mdrp0mb(s1)
        , mdapr(s1)
        , fx12(s2)
        , 'CALL 23 %s %s %s' % (s1,s2,sx,)
        , 'CALL 22 %s %s %s %s' % (s0,s1,s2,sx,)
        , srp0(s1)
        , f_dstr(s1,ds1)
        , add1
        , fx12(s2)
        , add2
        , f_dstr(sx,dsx)
        , addx
        )

def h_main_10(s0, s1,fx12,s2, s3, sx, ds1="",ds3="",dsx="",min3=True):
    s1,add1 = gen_alignrp(s1)
    s2,add2 = gen_alignrp(s2,a=2)
    s3,add3 = gen_alignrp(s3)
    sx,addx = gen_alignrp(sx)
    if add3:    add3 = pl(srp0(s3),add3)
    if addx:    addx = pl(srp0(sx),addx)
    if min3:
        fxx3=mdrp0mrw
    else:
        fxx3=mdrp0rw
    return pl(""
        , mdapr(sx)
        , fxx3(s3)
        , mdrp0rg(s1)
        , 'CALL 22 %s %s %s %s' % (s0,s1,s3,sx,)
        , srp0(s1)
        , f_dstr(s1,ds1)
        , add1
        , fx12(s2)
        , add2
        , f_dstr(s3,ds3)
        , add3
        , f_dstr(sx,dsx)
        , addx
        )

def h_main_01(s0, s1, s2,fx23,s3, sx, ds1="",ds2="",dsx="",min3=True):
    s1,add1 = gen_alignrp(s1)
    s2,add2 = gen_alignrp(s2)
    s3,add3 = gen_alignrp(s3,a=2)
    sx,addx = gen_alignrp(sx)
    if add1:    add1 = pl(srp0(s1),add1)
    if add3:    add3 = pl(srp0(s3),add3)
    if addx:    addx = pl(srp0(sx),addx)
    if min3:
        fxx3=mdrp0mrw
    else:
        fxx3=mdrp0rw
    return pl(""
        , mdapr(sx)
        , fxx3(s3)
        , mdrp0rg(s2)
        , mdrp0g(s3)
        , 'CALL 23 %s %s %s' % (s2,s3,sx,)
        , mdrp0rg(s1)
        , mdapr(s1)
        , 'CALL 22 %s %s %s %s' % (s0,s1,s2,sx,)
        , f_dstr(s1,ds1)
        , add1
        , srp0(s2)
        , f_dstr(s2,ds2)
        , add2
        , fx23(s3)
        , add3
        , f_dstr(sx,dsx)
        , addx
        )

#def h_main_2(s0, s1,fx12,s2, s3,fx34,s4, sx, ds1="",ds3="",dsx=""):
def h_main_2(s0, s1,fx12,s2, s3,fx34,s4, sx, ds1="",ds3="",dsx=""):
    s1,add1 = gen_alignrp(s1)
    s2,add2 = gen_alignrp(s2,a=2)
    s3,add3 = gen_alignrp(s3)
    s4,add4 = gen_alignrp(s4,a=2)
    sx,addx = gen_alignrp(sx,a=2)
    return pl(""
        , mdapr(sx)
        , mdrp0mw(s4)
        , mdrp0mb(s3)
        , mdapr(s3)
        , fx34(s4)
        , 'CALL 23 %s %s %s' % (s3,s4,sx,)
        , srp0(s4)
        , mdrp0g(s1)
        , mdapr(s1)
        , 'CALL 22 %s %s %s %s' % (s0,s1,s3,sx,)
        , srp0(s1)
        , f_dstr(s1,ds1)
        , add1
        , fx12(s2)
        , add2
        , srp0(s3)
        , f_dstr(s3,ds3)
        , add3
        , 'UTP %s' % (s4,)
        , fx34(s4)
        , add4
        , srp0(sx)
        , f_dstr(sx,dsx)
        , addx
#, srp0(s0)
#, 'SROUND 71'
#, mdrp0rw(s1,ds1)
#, 'RTG'
#, add1
#, fx12(s2)
#, add2
#, mdrp0rg(s4)
#, fx34(s3)
#, mdapr(s3)
#, add3
#, fx34(s4)
#, add4
#, srp0(s4)
#, 'SROUND 73'
#, mdrpmrw(sx,dsx)
#, 'RTG'
#, mdapr(sx)
#, addx
#, srp0(s1)
        )

#================================================
def vet_base(fx_cvt0,st,s1,fx12,s2):    #stem top
    return pl(""
        , 'CALL 24'
        , fx_cvt0(s1)
        , "RTG"
        , fx12(s2)
        )

def vet_a(s1,s2):
    return vet_base(evheight_shoot0_1,-1,s1,estemtc_2,s2)

def vet_C(s1,s2):
    return vet_base(ecvheight_shoot0_1,-1,s1,ecstemtc_2,s2)

def vet_n(st,s1,s2):
    s1,add1 = gen_alignrp(s1)
    s2,add2 = gen_alignrp(s2,2)
    return pl(""
        , evheight0_1(st)
        , 'CALL 24'
        , evheight_shoot0_1(s1)
        , add1
        , 'RTG'
        , estemtc_2(s2)
        , add2
        )

def vet_t(s1,s2):
    s1,add1 = gen_alignrp(s1)
    s2,add2 = gen_alignrp(s2,2)
    return pl(""
        , evheight0_1(s1)
        , add1
        , estemt_2(s2)
        , add2
        )

def veb_base(s0, fx_cvt0,s1,fx12,s2):   #stem base
    s1,add1 = gen_alignrp(s1)
    s2,add2 = gen_alignrp(s2,2)
    return pl(""
        , mdapr(s0)
        , 'CALL 24'     #if ppem>41 then rtdg
        , fx_cvt0(s1)
        , add1
        , 'RTG'
        , fx12(s2)
        , add2
        )

def veb_a(s0,s1,s2):
    return veb_base(s0,evbase_shoot0_1,s1,estemt_1,s2)

def veb_b(s0,s1,s2):
    return veb_base(s0,evbase_shoot0_1,s1,estemtc_1,s2)

def veb_C(s0,s1,s2):
    return veb_base(s0,evbase_shoot0_1,s1,ecstemtc_1,s2)

#================================================
pseudo_code_dict = {

    'exclam':
        packline(""
        , h_main_1(10, 6,estemw_1,8, 11)
        , srp0(6)
        , mdrpg(2)
        , srp0(8)
        , mdrpg(3)
        , ix()
        #y
        , sy()
        , mdapr(0)
        , mdrp0rg(3)
        , mdrp0mrw(4)
        , ecvheight0_1(8)
        , iy()
        ),

    'quotedbl':
        packline(""
        , h_main_2(12, 2,estemw_1,4, 8,estemw_1,10, 13)
        , ix()
        #y
        , sy()
        , ecvheight_shoot0_1(10)
        , alignrp(4)
        , mdrprg(6)
        , shprp2(0)
        , iy()
        ),

    'numbersign':
        packline(""
        , mdapr(7)
        , alignrp(11)
        , mdrp0rg(25)
        , alignrp(21)
        , f_ip([14,18,5,1])
        , mdrp0mrw(29)
        , ix()
        #y
        , sy()
        , mdapr(0)
        , alignrp(4)
        , mdrp0rg(19)
        , alignrp(15)
        , f_ip([21,25])
        , mdapr(21)
        , alignrp(17)
        , alignrp(13)
        , estemw_2(22)
        , shprp2(29)
        , shprp2(10)
        , mdapr(25)
        , alignrp(28)
        , alignrp(9)
        , estemw_2(26)
        , shprp2(2)
        , shprp2(6)
        , iy()
, sx()
, fo_mdrp(5,14,5,[4])
, fp_mdrp(5,14,4,[15])
, fp_mdrp(5,14,5,[6,9,10,13])
, fp_mdrp(4,15,4,[3,31,30,16])
, fo_mdrp(1,18,1,[0])
, fp_mdrp(1,18,0,[19])
, fp_mdrp(1,18,1,[2,28,29,17])
, fp_mdrp(0,19,0,[27,24,23,20])
        ),

    'dollar':
        packline(""
        , h_main_2(48, 5,estemw_1,6, 44,estemwc_1,30, 49)
        , srp0(5)
        , mdrp0g(13)
        , estemwc_1(38)
        , srp0(44)
        , mdrp0g(23)
        , estemw_1(22)
        , ip_round(5,44,9)
        , alignrp(1)
        , alignrp(34)
        , alignrp(16)
        , mdrpg(47)
        , shprp2(33)
        , shprp2(26)
        , shprp2(18)
        , ix()
        #y
        , sy()
        , mdapr(33)
        , alignrp(2)
        , mdrpg(0)
        , estemtc_1(41)
        , shprp2(9)
        #
        , mdapr(19)
        , alignrp(16)
        , mdrpg(18)
        , estemtc_2(26)
        , shprp2(35)
        , add_ip(19,33,[2,6])
        , add_ip(19,41,[34,27])
        , add_ip(26,33,[47,10])
        , iy()
        ),

    'percent':
        packline(""
        , h_main_2(52, 31,estemtc_thin_1,49, 19,estemtc_thin_1,13, 53)
        , srp0(31)
        , mdrp0g(37)
        , mdrp0rg(43)
        , mdapr(43)
        , estemtc_thin_1(37)
        , srp0(13)
        , mdrp0rg(7)
        , mdapr(7)
        , estemtc_thin_1(25)
        , add_ip(31,13,[1,2])
        , ix()
, fp_mdrp(1,2,1,[0])
        #y
        , sy()
        , mdapr(0)
        , mdrprg(3)
        , 'CALL 24'
        , mdrp0rg(4)
        , estem_124_1(16)
        , mdrp0rg(10)
        , estem_124_2(22)
        , srp0(3)
        , mdrp0rg(34)
        , estem_124_2(46)
        , mdrp0rg(28)
        , estem_124_1(40)
        , 'RTG'
        , iy()
        ),

    'ampersand':
        packline(""
        , h_main_2(54, 3,ecstemwc_1,51, 21,ecstemw_1,22, 55)
        , srp0(3)
        , mdrp0rg(9)
        , estemwc_1(41)
        , mdrp0rg(35)
        , estemwc_1(15)
        , add_ip(3,21,[6,47])
        , add_ip(51,22,[18,24])
        , add_ip(3,22,[32,48,19,29])
        , ix()
        #y
        , sy()
        , veb_b(54,0,44)
        , 'CALL 24'
        , ecvheight_shoot0_1(12)
        , srp2(54)
        , f_ip([21])
        , estemt_2(38)
        , add_ip(12,44,[32,19])
        , add_ip(38,0,[48,29])
        , add_ip(12,0,[6,18,47,24])
        , iy()
        ),

    'quotesingle':
        packline(""
        , h_main_1(6, 2,estem_205_1,4, 7)
        , ix()
        #y
        , sy()
        , ecvheight_shoot0_1(4)
        , mdrprg(0)
        , iy()
        ),

    'parenleft':
        packline(""
        , h_main_10(14, 4,estemwc_1,11, 0, 15)
        , srp0(0)
        , alignrp(8)
        , estem_124_2(1)
        , shprp2(7)
        , ix()
        #y
        , sy()
        , mdapr(0)
        , mdrprg(8)
        , iy()
        ),

    'parenright':
        packline(""
        , h_main_10(14, (1,7),estem_124_1,(0,8), 11, 15)
        , srp0(11)
        , estemwc_2(4)
        , ix()
        #y
        , sy()
        , mdapr(0)
        , mdrprg(8)
        , iy()
        ),

    'asterisk':
        packline(""
        , mdapr(14)
        , ix()
        #y
        , sy()
        , mdapr(15)
        , iy()
        ),

    'plus':
        packline(""
        , h_main_1(12, (1,5),estem_168_1,(11,7), 13)
        , srp0(1)
        , mdrpg(3)
        , srp0(11)
        , mdrpg(10)
        , ix()
        #y
        , sy()
        , mdapr(10)
        , alignrp(2)
        , mdrpg(0)
        , estem_1680_1(9)
        , shprp2(5)
        , mdrpg(7)
        , iy()
        ),

    'comma':
        packline(""
        , h_main_1(11, 5,estem_205_1,7, 12)
        , srp0(7)
        , mdrpg(4)
        , ix()
        #y
        , sy()
        , mdapr(4)
        , estem_205_1(7)
        , mdrpg(0)
        , iy()
        ),

    'hyphen':
        packline(""
        , h_edge(4, 1,3, 5)
        , ix()
        #y
        , sy()
        , mdapr(0)
        , ecstemtc_1(3)
        , iy()
        ),

    'period':
        packline(""
        , h_main_1(4, 1,estem_205_1,3, 5)
        , ix()
        #y
        , sy()
        , mdapr(0)
        , estem_205_1(3)
        , iy()
        ),

    'slash':
        packline(""
        , mdapr(1)
        , mdrpg(0)
        , mdapr(3)
        , mdrpg(2)
        , ix()
        #y
        , sy()
        , mdapr(0)
        , mdapr(3)
        , iy()
        ),

    'zero':
        packline(""
        , h_main_2(24, 3,ecstemwc_1,21, 15,ecstemw_1,9, 25)
        , ix()
        #y
        , sy()
        , veb_C(24,0,12)
        , vet_C(6,18)
        , iy()
        ),

    'one':
        packline(""
        , h_main_01(11, 5, (1,9),ecstemw_1,10, 12)
        , ix()
        #y
        , sy()
        , mdapr(0)
        , ecvheight0_1(10)
        , mdrp0g(6)
        , ecstemtc_2(5)
        , iy()
        ),

    'two':
        packline(""
        , h_main_2(30, 15,ecstemw_1,14, 8,ecstemwc_1,21, 31)
        , srp0(15)
        , mdrp0rg(1)
        , mdrpg(28,ds_slant)
        , srp0(21)
        , mdrpg(29)
        , ix()
        #y
        , sy()
        , mdapr(0)
        , ecstemt_1(29)
        , ecvheight_shoot0_1(18)
        , srp2(0)
        , f_ip([14])
        , ecstemtc_2(11)
        , add_ip(18,29,[5])
        , add_ip(11,0,[24])
        , iy()
        ),

    'three':
        packline(""
        , h_main_2(43, 3,ecstemw_1,4, 10,ecstemwc_1,40, 44)
        , srp0(3)
        , mdrp0rg(28)
        , ecstemw_1(27)
        , srp0(10)
        , mdrp0g(21)
        , ecstemwc_1(34)
        , ip_round(3,10,15)
        , ix()
        #y
        , sy()
        , veb_C(43,0,7)
        , vet_C(31,24)
        , ip_round(31,7,18)
        , mdrpg(13)
        , f_ip([37])
        , add_ip(31,0,[27,4])
        , iy()
        ),

    'four':
        packline(""
        , h_edge(14, 3, 9, 15)
        , ip_round(3,9,1)
        , alignrp(11)
        , alignrp(5)
        , ecstemw_1(10)
        , shprp2(6)
        , ix()
        #y
        , sy()
        , mdapr(0)
        , ecvheight0_1(6)
        , srp2(0)
        , f_ip([8])
        , mdapr(8)
        , alignrp(11)
        , alignrp(4)
        , ecstemt_2(9)
        , shprp2(2)
        , iy()
, sx()
, fo_mdrp(4,5,4,[13])
, sx()
, f_dstr(13,ds_slant)
, sy()
, fp_mdrp(4,5,13,[12])
        ),

    'five':
        packline(""
        , h_main_2(29, 3,ecstemw_1,4, 10,ecstemwc_1,26, 30)
        , srp0(3)
        , mdrpg(16)
        , mdrpg(17)
        , srp0(26)
        , mdrpg(19)
        , ix()
        #y
        , sy()
        , veb_C(29,0,7)
        , ecvheight0_1(18)
        , ecstemt_2(19)
        , ip_round(18,7,23)
        , ecstemtc_2(13)
        , iy()
, sx()
, fo_mdrp(16,17,16,[15,21])
, sx()
, f_dstr(15,ds_slant)
, f_dstr(21,ds_slant)
, fp_mdrp(16,17,21,[20])
        ),

    'six':
        packline(""
        , h_main_2(37, 3,ecstemwc_1,16, 28,ecstemwc_1,22, 38)
        , srp0(16)
        , mdrpg(34)
        , srp0(28)
        , mdrp0g(10)
        , ecstemw_1(9)
        , ix()
        #y
        , sy()
        , veb_C(37,0,25)
        , vet_C(6,13)
        , ip_round(6,25,19)
        , ecstemtc_2(31)
        , add_ip(6,0,[10])
        , iy()
        ),

    'seven':
        packline(""
        , h_edge(11, 5, 8, 12)
        , ip_round(5,8,1)
        , ecstemwc_1(0)
        , srp0(8)
        , mdrpg(4)
        , ix()
        #y
        , sy()
        , mdapr(0)
        , ecvheight0_1(7)
        , ecstemt_2(8)
        , shprp2(4)
        , iy()
        ),

    'eight':
        packline(""
        , h_main_2(48, 3,ecstemwc_1,45, 39,ecstemwc_1,21, 49)
        , srp0(3)
        , mdrp0g(9)
        , ecstemwc_1(33)
        , srp0(39)
        , mdrp0g(27)
        , ecstemwc_1(15)
        , ix()
        #y
        , sy()
        , veb_C(48,0,36)
        , vet_C(12,30)
        , ip_round(12,36,24)
        , ecstemtc_2(42)
        , f_ip([6,18])
        , iy()
        ),

    'nine':
        packline(""
        , h_main_2(37, 16,ecstemwc_1,34, 10,ecstemwc_1,22, 38)
        , srp0(10)
        , mdrpg(28)
        , srp0(16)
        , mdrp0g(3)
        , ecstemw_1(4)
        , ix()
        #y
        , sy()
        , veb_C(37,0,7)
        , vet_C(19,31)
        , ip_round(0,31,13)
        , ecstemtc_1(25)
        , add_ip(19,0,[4])
        , iy()
        ),

    'colon':
        packline(""
        , h_main_1(8, (1,5),estem_205_1,(3,7), 9)
        , ix()
        #y
        , sy()
        , mdapr(0)
        , estem_205_1(3)
        , mdapr(4)
        , estem_205_1(7)
        , iy()
        ),

    'semicolon':
        packline(""
        , h_main_1(15, (5,12),estem_205_1,(7,14), 16)
        , srp0(7)
        , mdrpg(4)
        , ix()
        #y
        , sy()
        , mdapr(4)
        , estem_205_1(7)
        , mdapr(11)
        , estem_205_1(14)
        , iy()
        ),

    'less':
        packline(""
        , h_edge(7, 1, (0,4), 8)
        , srp0(1)
        , mdrpg(5)
        , ix()
        #
        , sy()
        , mdapr(0)
        , mdapr(3)
        , iy()
        ),

    'equal':
        packline(""
        , h_edge(8, (1,5), (3,7), 9)
        , ix()
        #
        , sy()
        , mdapr(0)
        , estem_168_1(3)
        , mdapr(4)
        , estem_168_1(7)
        , iy()
        ),

    'greater':
        packline(""
        , h_edge(7, (0,3), 6, 8)
        , srp0(6)
        , mdrpg(2)
        , ix()
        #
        , sy()
        , mdapr(0)
        , mdapr(4)
        , iy()
        ),

    'question':
        packline(""
        , h_main_2(28, 17,ecstemw_1,16, 10,ecstemwc_1,23, 29)
        , ip_round(17,10,1)
        , estem_205_1(3)
        , mdrp0g(5)
        , ecstemw_1(4)
        , ix()
        #
        , sy()
        , mdapr(0)
        , estem_2050_1(3)
        , mdrp0mrw(4)
        , mdapr(20)
        , ecstemtc_2(13)
        , add_ip(20,0,[16])
        , iy()
        ),

    'at':
        packline(""
        , h_main_2(66, 3,estemtc_thin_1,44, 38,estemtc_thin_1,9, 67)
        , ip_round(3,38,21)
        , estemw_1(63)
        , ip_round(21,38,28)
        , mdrpg(57)
        , mdrpg(15)
        , estemw0_1(29)
        , mdrpg(30)
        , srp0(38)
        , mdrp0g(50)
        , mdrpg(51)
        , ix()
        #y
        , sy()
        , 'CALL 24'
        , mdapr(0)
        , 'RTG'
        , estemtc_thin_1(47)
        , mdapr(18)
        , estemtc_1(54)
        , 'CALL 24'
        , mdrp0rg(12)
        , 'RTG'
        , estemtc_1(35)
        , mdapr(28)
        , 'CALL 24'
        , mdrp0rg(24)
        , 'RTG'
        , estemtc_2(60)
        , srp0(28)
        , 'CALL 24'
        , mdrp0rg(6)
        , 'RTG'
        , estemtc_thin_2(41)
        , add_ip(6,0,[50])
        , iy()
        ),

    'A':
        packline(""
        , h_edge(11, 5, 0, 12, min2=False)
        , ix()
        #y
        , sy()
        , mdapr(0)
        , alignrp(4)
        , ecvheight0_1(7)
        , ip_round(7,0,8)
        , ecstemt_2(2)
        , iy()
, sx()
, fo_mdrp(5,6,5,[4])
, fo_mdrp(0,7,0,[1])
, sx()
, f_dstr(4,ds_ec_slant)
, f_dstr(1,ds_ec_slant,direction='-')
, sy()
, fp_mdrp(5,6,4,[9])
, sx()
, fp_mdrp(5,6,4,[3,10])
, fp_mdrp(0,7,1,[2,8])
        ),

    'B':
        packline(""
        , h_main_2(33, 1,ecstemw_1,(31,22), 27,ecstemwc_1,12, 34)
        , srp0(27)
        , mdrp0g(18)
        , estemwc_1(6)
        , ix()
        #y
        , sy()
        , mdapr(0)
        , ecstemt_1(24)
        , ecvheight0_1(3)
        , ecstemt_2(21)
        , ip_round(3,24,15)
        , ecstemt_2(30)
        , f_ip([9])
        , iy()
        ),

    'C':
        packline(""
        , h_main_2(26, 3,ecstemwc_1,16, (22,10),ecstemw_1,(23,9), 27)
        , ix()
        #y
        , sy()
        , veb_C(26,0,19)
        , vet_C(6,13)
        , add_ip(6,0,[10,22])
        , iy()
        ),

    'D':
        packline(""
        , h_main_2(18, 1,ecstemw_1,16, 12,ecstemwc_1,6, 19)
        , ix()
        #y
        , sy()
        , mdapr(0)
        , ecstemt_1(9)
        , ecvheight0_1(3)
        , ecstemt_2(15)
        , iy()
        ),

    'E':
        packline(""
        , h_main_10(12, 1,ecstemw_1,(9,5), (0,4), 13)
        , srp0(0)
        , mdrpg(8)
        , ix()
        #y
        , sy()
        , mdapr(0)
        , ecstemt_1(11)
        , ecvheight0_1(3)
        , ecstemt_2(4)
        , ip_round(3,11,7)
        , ecstemt_2(8)
        , iy()
        ),

    'F':
        packline(""
        , h_main_10(10, 1,ecstemw_1,(9,5), 4, 11)
        , srp0(4)
        , mdrpg(8)
        , ix()
        #y
        , sy()
        , mdapr(0)
        , ecvheight0_1(3)
        , ecstemt_2(4)
        , ip_round(3,0,7)
        , ecstemt_2(8)
        , iy()
        ),

    'G':
        packline(""
        , h_main_2(30, 3,ecstemwc_1,16, 22,ecstemw_1,27, 31)
        , ip_round(16,22,24)
        , srp0(22)
        , mdrp0g(10)
        , ecstemw_1(9)
        , ix()
        #y
        , sy()
        , veb_C(30,0,19)
        , vet_C(6,13)
        , ip_round(6,19,25)
        , ecstemt_2(24)
        , iy()
        ),

    'H':
        packline(""
        , h_main_2(12, 5,ecstemw_1,(3,7), (1,9),ecstemw_1,11, 13)
        , ix()
        #y
        , sy()
        , mdapr(0)
        , alignrp(4)
        , ecvheight0_1(11)
        , alignrp(7)
        , ip_round(11,0,9)
        , ecstemt_2(2)
        , iy()
        ),

    'I':
        packline(""
#        , h_main_1(12, 3,ecstemw_1,9, 13)
#        , srp0(3)
#        , mdrpg(2)
#        , shprp2(5)
#        , srp0(9)
#        , mdrpg(11)
#        , shprp2(8)
#
#, h_main_10(12, 3,ecstemw_1,9, 11, 13)
#        , srp0(3)
, mdapr(3)
        , mdrpg(2)
        , shprp2(5)
#        , srp0(9)
, ecstemw0_1(9)
#        , mdrpg(11)
#        , shprp2(8)
, mdrp0g(11)
, alignrp(8)
, mdrpmrw(13)

        , ix()
        #y
        , sy()
        , mdapr(0)
        , ecstemt_thin_1(11)
        , shprp2(3)
        , ecvheight0_1(7)
        , ecstemt_thin_2(8)
        , shprp2(4)
        , iy()
        ),

    'J':
        packline(""
        , h_main_2(18, 3,ecstemw_1,4, 10,ecstemw_1,14, 19)
        , srp0(10)
        , mdrpg(12)
        , ix()
        #y
        , sy()
        , veb_C(18,0,7)
        , ecvheight0_1(14)
        , ecstemt_thin_2(11)
        , add_ip(0,14,[4])
        , iy()
        ),

    'K':
        packline(""
        , h_main_10(12, 5,ecstemw_1,(3,7), 10, 13)
        , ix()
        #y
        , sy()
        , mdapr(0)
        , alignrp(4)
        , ecvheight0_1(10)
        , alignrp(7)
        , iy()
, sx()
, fo_mdrp(9,8,10,[9])
, sx()
, f_dstr(9,ds_ec_slant,direction='-')
, fp_mdrp(9,8,10,[11,2])
, fo_mdrp(0,11,0,[1])
, sx()
, f_dstr(1,ds_ec_slant,direction='-')
, fp_mdrp(0,11,1,[2])
, sy()
, fp_mdrp(9,8,10,[2,3])
, sx()
, fp_mdrp(0,11,1,[2])
        ),

    'L':
        packline(""
        , h_main_10(6, 1,ecstemw_1,3, 5, 7)
        , ix()
        #y
        , sy()
        , mdapr(0)
        , ecstemt_1(5)
        , ecvheight0_1(3)
        , iy()
        ),

    'M':
        packline(""
        , h_main_2(13, 7,ecstemw_1,(5,9), (1,11),ecstemw_1,12, 14)
        , ix()
        #y
        , sy()
        , mdapr(0)
        , alignrp(6)
        , ecvheight0_1(12)
        , alignrp(9)
        , iy()
, sx()
, fo_mdrp(10,9,10,[4])
, fo_mdrp(10,11,10,[3])
, sy()
, f_dstr(10,ds_ec_slant)
, fp_mdrp(10,9,4,[5])
, fp_mdrp(10,11,3,[2])
, sy()
, f_dstr(5,ds_ec_slant,direction="-")
, f_dstr(2,ds_ec_slant,direction="-")
        ),

    'N':
        packline(""
        , h_main_2(10, 4,ecstemw_1,(2,6), (1,7),ecstemw_1,9, 11)
        , ix()
        #y
        , sy()
        , mdapr(0)
        , alignrp(3)
        , ecvheight0_1(9)
        , alignrp(6)
        , iy()
, fo_mdrp(6,7,6,[2])
, fo_mdrp(1,2,1,[7])
, sy()
, f_dstr(7,ds_ec_slant)
, f_dstr(2,ds_ec_slant,direction="-")
        ),

    'O':
        packline(""
        , h_main_2(24, 3,ecstemwc_1,21, 15,ecstemwc_1,9, 25)
        , ix()
        #y
        , sy()
        , veb_C(24,0,12)
        , vet_C(6,18)
        , iy()
        ),

    'P':
        packline(""
        , h_main_2(20, 1,ecstemw_1,(10,18), 14,ecstemwc_1,6, 21)
        , ix()
        #y
        , sy()
        , mdapr(0)
        , ecvheight0_1(3)
        , ecstemt_2(17)
        , ip_round(3,0,11)
        , ecstemt_2(9)
        , iy()
        ),

    'Q':
        packline(""
        , h_main_2(55, 3,ecstemwc_1,38, 32,ecstemwc_1,9, 56)
        , add_ip(3,9,[6,35,26,50,44,0,14,20])
        , add_ip(3,32,[47])
        , add_ip(38,9,[53,12])
        , ix()
        #y
        , sy()
        , veb_C(55,(0,20),44)
        , vet_C(6,35)
        , ip_round(6,44,26)
        , ecstemt_thin_2(50)
        , srp0(20)
        , ecstemt_thin_1(14)
        , iy()
        ),

    'R':
        packline(""
        , h_main_2(23, 5,ecstemw_1,(3,21), 17,ecstemwc_1,10, 24)
        , ix()
        #y
        , sy()
        , mdapr(0)
        , alignrp(4)
        , ecvheight0_1(7)
        , ecstemt_2(20)
        , ip_round(3,0,14)
        , ecstemt_2(2)
        , f_ip([13])
        , iy()
, sx()
, fo_mdrp(0,13,0,[1])
, sx()
, f_dstr(1,ds_ec_slant,direction='-')
, fp_mdrp(0,13,1,[2])
        ),

    'S':
        packline(""
        , h_main_2(40, 3,estemw_1,4, 10,estemwc_1,37, 41)
        , srp0(3)
        , mdrp0g(17)
        , estemwc_1(30)
        , srp0(10)
        , mdrp0g(24)
        , estemw_1(23)
        , ix()
        #y
        , sy()
        , veb_C(40,0,7)
        , vet_C(20,27)
        , add_ip(20,7,[34])
        , add_ip(27,0,[13])
        , add_ip(20,0,[24,4])
        , iy()
        ),

    'T':
        packline(""
#        , mdapr(9)
#        , mdrp0mw(6)
#        , mdrp0g(7)
#        , mdrp0rg(1)
#        , mdapr(1)
#        , ecstemw0_1(7)
#        , mdrpg(6)
#        , srp0(1)
#        , mdrpg(3)
#        , 'CALL 22 8 3 6 9'
#        , ip_round(3,6,1)
#        , ecstemw_1(7)
, srp0(8)
, mdrp0rg(1)
, mdrpg(3)
, ecstemw0_1(7)
, mdrp0g(5)
, mdrpmrw(9)
        , ix()
        #y
        , sy()
        , mdapr(0)
        , ecvheight0_1(5)
        , ecstemt_2(6)
        , shprp2(2)
        , iy()
        ),

    'U':
        packline(""
        , h_main_2(18, 3,ecstemw_1,5, 12,ecstemw_1,14, 19)
        , ix()
        #y
        , sy()
        , veb_C(18,0,9)
        , ecvheight0_1(14)
        , alignrp(5)
        , iy()
        ),

    'V':
        packline(""
        , h_edge(7, 2, 6, 8, min2=False)
        , ix()
        #y
        , sy()
        , mdapr(0)
        , ecvheight0_1(6)
        , alignrp(3)
        , iy()
, sx()
, fo_mdrp(2,1,2,[3])
, fo_mdrp(6,0,6,[5])
, sx()
, f_dstr(3,ds_ec_slant)
, f_dstr(5,ds_ec_slant,direction="-")
, sy()
, fp_mdrp(2,1,3,[4])
        ),

    'W':
        packline(""
        , h_edge(13, 5, 12, 14, min2=False)
        , ix()
        #y
        , sy()
        , mdapr(0)
        , alignrp(3)
        , ecvheight0_1(12)
        , alignrp(9)
        , alignrp(6)
        , iy()
, sx()
, fo_mdrp(5,4,5,[6])
, fo_mdrp(12,0,12,[11])
, sx()
, f_dstr(6,ds_ec_slant)
, f_dstr(11,ds_ec_slant,direction="-")
, sy()
, fp_mdrp(5,4,6,[7])
, fp_mdrp(12,0,11,[10])
, sy()
#, f_dstr(2,ds_ec_slant,direction="-")
, fp_mdrp(7,8,3,[2])
        ),

    'X':
        packline(""
        , h_edge(12, 4, 0, 13, min2=False)
        , ix()
        #y
        , sy()
        , mdapr(0)
        , alignrp(3)
        , ecvheight0_1(10)
        , alignrp(7)
        , iy()
, sx()
, fo_mdrp(4,9,4,[3])
, fo_mdrp(0,7,0,[1])
, sx()
, f_dstr(3,ds_ec_slant)
, f_dstr(1,ds_ec_slant,direction="-")
, fp_mdrp(1,6,0,[7,11])
, fp_mdrp(3,10,4,[9,5])
, sy()
, fp_mdrp(4,9,4,[5,8])
, fp_mdrp(3,10,3,[2,11])
        ),

    'Y':
        packline(""
        , mdapr(10)
        , mdrp0w(7)
        , mdrp0g(8)
        , mdrp0rg(1)
        , mdapr(1)
        , mdrpg(3)
        , 'CALL 22 9 3 7 10'
        , ip_round(3,7,1)
        , ecstemw0_1(8)
        , mdrpg(7)
        , ix()
        #y
        , sy()
        , mdapr(0)
        , ecvheight0_1(7)
        , alignrp(4)
        , iy()
, sx()
, fo_mdrp(3,2,3,[4])
, fo_mdrp(7,8,7,[6])
, sx()
, f_dstr(4,ds_ec_slant)
, f_dstr(6,ds_ec_slant,direction="-")
, sy()
, fp_mdrp(3,2,4,[5])
        ),

    'Z':
        packline(""
        , h_edge(10, 1, 7, 11)
        , srp0(1)
        , mdrpg(4)
        , srp0(7)
        , mdrpg(9)
        , ix()
        #y
        , sy()
        , mdapr(0)
        , ecstemt_1(9)
        , shprp2(2)
        , ecvheight0_1(6)
        , ecstemt_2(3)
        , shprp2(7)
        , iy()
, sx()
, fo_mdrp(2,3,2,[8])
, fo_mdrp(7,8,7,[3])
, sx()
, f_dstr(8,ds_ec_slant)
, f_dstr(3,ds_ec_slant,direction="-")
        ),

    'bracketleft':
        packline(""
        , h_edge(8, 1, (7,3), 9)
        , srp0(1)
        , estemw_1(5)
        , ix()
        #y
        , sy()
        , mdapr(0)
        , estemt_1(7)
        , mdapr(3)
        , estemt_2(4)
        , iy()
        ),

    'backslash':
        packline(""
        , mdapr(2)
        , ix()
        #y
        , sy()
        , mdapr(0)
        , mdapr(3)
        , iy()
, sx()
, fo_mdrp(2,1,2,[3])
        ),

    'bracketright':
        packline(""
        , h_edge(8, (1,5), 7, 9)
        , srp0(7)
        , estemw_2(3)
        , ix()
        #y
        , sy()
        , mdapr(1)
        , estemt_1(2)
        , mdapr(6)
        , estemt_2(5)
        , iy()
        ),

    'asciicircum':
        packline(""
        , h_edge(7, 4, 0, 8)
        , ix()
        #y
        , sy()
        , mdapr(0)
        , alignrp(3)
        , mdapr(6)
        , iy()
, sx()
, fo_mdrp(4,5,4,[3])
, fo_mdrp(0,6,0,[1])
, sy()
, fp_mdrp(4,5,3,[2])
        ),

    'underscore':
        packline(""
        , h_edge(4, 1, 3, 5, min2=False)
        , ix()
        #y
        , sy()
        , mdapr(0)
        , mdrpmb(3)
        , iy()
        ),

    'grave':
        packline(""
        , mdapr(0)
        , ix()
        #y
        , sy()
        , mdapr(3)
        , mdrpmb(0)
        , iy()
        ),

    'a':
        packline(""
        , h_main_2(46, 9,estemwc_1,43, (36,15,3),estemw_1,29, 47)
        , srp0(9)
        , mdrp0g(23)
        , estemw_1(22)
        , ix()
        #y
        , sy()
        , veb_a(1,6,33)
        , vet_a(26,19)
        , srp2(1)
        , f_ip([22])
        , add_ip(26,33,[13])
        , add_ip(19,6,[39])
        , iy()
        ),

    'b':
        packline(""
        , h_main_2(29, 1,estemw_1,(26,4,0), 20,estemwc_1,10, 30)
        , ix()
        #y
        , sy()
        , veb_b(0,13,17)
        , evheight_b0_1(3)
        , vet_a(7,23)
        , iy()
        ),

    'c':
        packline(""
        , h_main_2(26, 3,estemwc_1,16, (22,10),estemw_1,(23,9), 27)
        , ix()
        #y
        , sy()
        , veb_b(26,0,19)
        , vet_a(6,13)
        , add_ip(6,26,[10,22])
        , iy()
        ),

    'd':
        packline(""
        , h_main_2(29, 8,estemwc_1,26, (20,14,2),estemw_1,16, 30)
        , ix()
        #y
        , sy()
        , veb_b(1,5,17)
        , evheight_b0_1(15)
        , vet_a(11,23)
        , iy()
        ),

    'e':
        packline(""
        , h_main_2(28, 3,estemwc_1,(11,27), 21,estemwc_1,9, 29)
        , srp0(21)
        , mdrp0rg(17)
        , estemw_1(18)
        , ix()
        #y
        , sy()
        , veb_b(28,0,14)
        , vet_a(6,24)
        , add_ip(6,28,[21,17])
        , 'SROUND 74'
        , mdapr(21)
        , 'RTG'
        , estemt_2(10)
        , iy()
        ),

    'f':
        packline(""
        , h_main_1(22, (1,5),estemw_1,(21,17), 23)
        , srp0(1)
        , mdrpg(3)
        , srp0(21)
        , mdrpg(19)
        , mdrprg(12)
        , ix()
        #y
        , sy()
        , mdapr(0)
        , vet_t((18,5),(21,2))
        , 'CALL 24'
        , mdrp0rg(9)
        , 'RTG'
        , estemtc_2(14)
        , iy()
        ),

    'g':
        packline(""
        , h_main_2(41, 3,estemwc_1,38, (32,9,25),estemw_1,11, 42)
        , srp0(3)
        , mdrp0g(18)
        , estemw_1(19)
        , ix()
        #y
        , sy() 
        , mdapr(0)
        , estemtc_1(29)
        , 'CALL 24'
        , mdrp0rg(15)
        , 'RTG'
        , f_ip([19])
        , estemtc_1(22)
        , vet_n(11,6,35)
        , iy()
        ),

    'h':
        packline(""
        , h_main_2(20, 10,estemw_1,(8,13), 1,estemw_1,19, 21)
        , ix()
        #y
        , sy()
        , mdapr(0)
        , alignrp(9)
        , evheight_b0_1(12)
        , vet_a(16,5)
        , iy()
        ),

    'i':
        packline(""
        , h_main_1(8, (1,5),estemw_1,(3,7), 9)
        , ix()
        #y
        , sy()
        , mdapr(0)
        , evheight0_1(3)
        , mdrp0mrw(4)
        , mdrp0mb(7)
        , iy()
        ),

    'j':
        packline(""
        , h_main_1(18, (8,16),estemw_1,(10,17), 19)
        , srp0(8)
        , mdrp0g(3)
        , ix()
        #y
        , sy()
        , mdapr(18)
        , 'CALL 24'
        , mdrp0rg(0)
        , 'RTG'
        , estemtc_1(5)
        , evheight0_1(10)
        , mdrp0mrw(14)
        , mdrp0mb(17)
        , iy()
        ),

    'k':
        packline(""
        , h_main_10(12, 5,estemw_1,(3,7), 10, 13)
        , ix()
        #y
        , sy()
        , mdapr(0)
        , alignrp(4)
        , evheight_b0_1(7)
        , evheight0_1(10)
        , iy()
, sx()
, fo_mdrp(10,11,10,[9])
, sx()
, f_dstr(9,ds_slant,direction="-")
, srp0(10)
, mdrpg(0)
, fp_mdrp(9,8,10,[11])
, sx()
, fo_mdrp(0,11,0,[1])
, sx()
, f_dstr(1,ds_slant,direction="-")
, sy()
, fp_mdrp(9,8,10,[2,3])
, sx()
, fp_mdrp(0,11,1,[2])
        ),

    'l':
        packline(""
        , h_main_1(4, 1,estemw_1,3, 5)
        , ix()
        #y
        , sy()
        , mdapr(0)
        , evheight_b0_1(3)
        , iy()
        ),

    'm':
        packline(""
        , mdapr(36)
        , mdrp0mw(34)
        , mdrp0rb(1)
        , mdapr(1)
        , estemw_1(34)
        , 'CALL 23 1 34 36'
        , mdrp0rg(10)
        , mdrp0rg(19)
        , 'CALL 22 35 19 1 36'
        , f_dstr(19,"11+8 14-8 15-8 17-8 18-8 24+8 27+8 ")
        , srp0(19)
        , estemw_1(17)
        , shprp2(21)
#        , mdrp0rg(10)
, ip_round(19,1,10,"21-8 29-8 31-8 32-8 34+8 37+8 40+8 41+8 ")
        , estemw_1(8)
        , f_ip([28])
        , f_dstr(1,"21-8 29-8 31-8 32-8 34+8 37+8 40+8 41+8 ")
        , srp0(1)
        , estemw_1(34)
        , f_dstr(36,"21-8 29-8 31-8 32-8 37+8 40+8 41+8 ")
        , ix()
        #y
        , sy()
        , mdapr(0)
        , alignrp(9)
        , alignrp(18)
        , vet_n(21,(25,31),(14,5))
        , iy()
        ),

    'n':
        packline(""
        , h_main_2(20, 10,estemw_1,(8,13), 1,estemw_1,19, 21)
        , ix()
        #y
        , sy()
        , mdapr(0)
        , alignrp(9)
        , vet_n(12,16,5)
        , iy()
        ),

    'o':
        packline(""
        , h_main_2(24, 3,estemwc_1,21, 15,estemwc_1,9, 25)
        , ix()
        #y
        , sy()
        , veb_b(24,0,12)
        , vet_a(6,18)
        , iy()
        ),

    'p':
        packline(""
        , h_main_2(29, 1,estemw_1,(26,4,0), 20,estemwc_1,10, 30)
        , ix()
        #y
        , sy()
        , veb_b(29,13,17)
        , vet_n(3,7,23)
        , evheight_p0_1(1)
        , iy()
        ),

    'q':
        packline(""
        , h_main_2(29, 8,estemwc_1,26, (20,14,1),estemw_1,16, 30)
        , ix()
        #y
        , sy()
        , veb_b(29,5,17)
        , vet_n(15,11,23)
        , evheight_p0_1(1)
        , iy()
        ),

    'r':
        packline(""
        , h_main_1(16, 1,estemw_1,(15,3), 17)
        , mdrpg(9)
        , ix()
        #y
        , sy()
        , mdapr(0)
        , vet_n(3,7,12)
        , iy()
        ),

    's':
        packline(""
        , h_main_2(36, 3,estemw_1,4, 10,estemwc_1,33, 37)
        , srp0(3)
        , mdrp0g(15)
        , estemwc_1(28)
        , srp0(10)
        , mdrp0g(22)
        , estemw_1(21)
        , ix()
        #y
        , sy()
        , veb_b(36,0,7)
        , vet_a(18,25)
        , add_ip(18,7,[30])
        , add_ip(25,0,[12])
        , add_ip(18,0,[22,4])
        , iy()
        ),

    't':
        packline(""
        , h_main_1(22, (3,7),estemw_1,(13,9), 23)
        , srp0(3)
        , mdrpg(5)
        , srp0(13)
        , mdrpg(11)
        , mdrpg(20)
        , ix()
        #y
        , sy()
        , veb_a(22,0,17)
        , vet_t((10,7),(13,4))
        , mdrpg(9)
        , iy()
        ),

    'u':
        packline(""
        , h_main_2(20, 8,estemw_1,10, (17,1),estemw_1,19, 21)
        , ix()
        #y
        , sy()
        , veb_b(20,5,14)
        , evheight0_1(18)
        , alignrp(10)
        , iy()
        ),

    'v':
        packline(""
        , mdapr(2)
        , mdapr(6)
        , mdrprg(8)
        , add_ip(2,6,[4])
        , ix()
        #y
        , sy()
        , mdapr(0)
        , evheight0_1(6)
        , alignrp(3)
        , iy()
, sx()
, fo_mdrp(2,1,2,[3])
, fo_mdrp(6,0,6,[5])
, sx()
, f_dstr(3,ds_slant)
, f_dstr(5,ds_slant,direction="-")
, sy()
, fp_mdrp(2,1,3,[4])
        ),

    'w':
        packline(""
        , mdapr(5)
        , mdapr(12)
        , mdrprg(14)
        , add_ip(5,12,[7,2,10])
        , ix()
        #y
        , sy()
        , mdapr(0)
        , alignrp(3)
        , evheight0_1(12)
        , alignrp(9)
        , alignrp(6)
        , iy()
, sx()
, fo_mdrp(5,4,5,[6])
, fo_mdrp(12,0,12,[11])
, sx()
, f_dstr(6,ds_slant)
, f_dstr(11,ds_slant,direction="-")
, sy()
, fp_mdrp(5,4,6,[7])
, fp_mdrp(12,0,11,[10])
, fp_mdrp(7,8,3,[2])
#, sy()
#, f_dstr(2,ds_slant,direction="-")
        ),

    'x':
        packline(""
        , mdapr(4)
        , mdrpg(6)
        , mdapr(0)
        , mdrpg(10)
        , mdrprg(13)
        , add_ip(4,0,[2,8])
        , ix()
        #y
        , sy()
        , mdapr(0)
        , alignrp(3)
        , evheight0_1(10)
        , alignrp(7)
        , iy()
, sx()
, fo_mdrp(4,9,4,[3])
, fo_mdrp(0,7,0,[1])
, sx()
, f_dstr(3,ds_slant)
, f_dstr(1,ds_slant,direction="-")
, fp_mdrp(3,10,4,[9])
, fp_mdrp(1,6,0,[7])
, fp_mdrp(4,9,4,[5])
, fp_mdrp(0,7,0,[11])
, sy()
, fp_mdrp(3,10,3,[2])
, fp_mdrp(7,0,7,[8])
        ),

    'y':
        packline(""
        , mdapr(9)
        , mdapr(13)
        , mdrprg(18)
        , add_ip(9,13,[11])
        , ix()
        #y
        , sy()
        , mdapr(17)
        , 'CALL 24'
        , mdrp0rg(0)
        , estemtc_1(5)
        , evheight0_1(13)
        , alignrp(10)
        , iy()
, sx()
, fo_mdrp(9,8,9,[10])
, fo_mdrp(13,14,13,[12])
, sx()
, f_dstr(10,ds_slant)
, f_dstr(12,ds_slant,direction="-")
, sy()
, fp_mdrp(9,8,10,[11])
, sy()
, f_dstr(11,ds_slant,direction="-")
        ),

    'z':
        packline(""
        , mdapr(1)
        , mdrpg(4)
        , mdrp0rg(7)
        , mdrpg(9)
        , mdrpmrw(11)
        , ix()
        #y
        , sy()
        , mdapr(0)
        , estemt_1(9)
        , evheight0_1(6)
        , estemt_2(3)
        , iy()
, sx()
, fo_mdrp(2,3,2,[8])
, fo_mdrp(7,8,7,[3])
, sx()
, f_dstr(8,ds_slant)
, f_dstr(3,ds_slant,direction="-")
, sy()
, fp_mdrp(7,8,3,[2])
, fp_mdrp(2,3,7,[8])
        ),

    'uni0E01':      #KO KAI
        packline(""
        , hf_ko_kai(25, 14,12, 18,17, 10,8)
        , tgr_140(26, 1,24)
        , add_ip(14,24,[5,21])
        , ix()
        #y
        , sy()
        , mdap(1)
        , alignrp(13)
        , tvtc2(21,[15,12,2,24, 18,8,17,9,10])
        , tstemt_2(5)
        , iy()
        ),

    'uni0E02':    #KHO KHAI
        packline(""
        , hf_kho_khai(44, 19,10, 13, [41,35])
        , hr_kho_khai(45, 29,31, 1,28, 4,25)
        , ix()
        , dh2(16)
        #y
        , sy()
        , mdap(1)
        , tstemt_1(28)
        , tvt2(31)
        , v_head_kho_khai(22,[2,27,4,25], 7, 10,16,[32,38])
        , iy()
        , dh2(13)
        ),

    'uni0E03':    #KHO KHUAT
        packline(""
        , hf_kho_khai(50, 23,12, 17, [47,41])
        , hr_kho_khai(51, 35,37, 1,34, 4,31)
        , add_ip(23,31, [26,27,28, 7,8,9])
        , ix()
        , dh1(14)
        , dh2(20)
        #y
        , sy()
        , mdap(1)
        , tstemt_1(34)
        , tvt2(37)
        , v_head_kho_khuat(28,26,[4,31,2,33], 7,9, 8,27, 14,20,[38,44])
        , iy()
        , dh2(17)
        ),

    'uni0E04':    #KHO KHWAI
        packline(""
        , hf_kho_khwai(55, 36,8, 30,29, 11, 14,20,[52,46,26])
        , tgr_140(56,1,42)
        , add_ip(36,42,[39,5])
        , ix()
        , dh1(17)
        , dh2(23)
        #y
        , sy()
        , mdap(1)
        , alignrp(29)
        , v_top_kho_khwai(39,[36,8,11,2,42],5, 17,23,[43,49,26,14])
        , dx(26,12)
        , dx(11,-16)
        , iy()
        , dh2(20)
        ),

    'uni0E05':    #KHO KHON
        packline(""
        , hf_kho_khwai(55, 36,8, 30,29, 11, 14,20,[52,46,26])
        , tgr_140(56,1,42)
        , add_ip(36,42,[38,39,40,4,5,6])
        , ix()
        , dh1(17)
        , dh2(23)
        #y
        , sy()
        , mdap(1)
        , alignrp(29)
        , v_top_kho_khon(40,38,[36,8,11,2,42],4,6, 5,39, 17,23,[43,49,26,14])
        , dx(26,12)
        , dx(11,-16)
        , iy()
        , dh2(20)
        ),

    'uni0E06':    #KHO RAKHANG
        packline(""
        , hf_kho_khai(74,35,24, 29,[59,53])
        , tgr_160(75,47,49)
        , alignrp(1)
        , mdrp0rg(13,"24+8 ")
        , tstemw_1(45)
        , shprp2(2)
        , xhead1(8,71,65)
        , srp0(13)
        , mdrp0rg(16,"15+8 ")
        , tstemw_1(43)
        , add_ip(35,43,[38,39,40,19,20,21])
        , ix()
        , dh1(26,11)
        , dh2(32,5)
        #y
        , sy()
        , mdap(1)
        , tstemt_1(47)
        , tvt2(49)
        , v_head_kho_khuat(40,38,[16,43,14,45], 19,21, 20,39, 26,32,[50,56])
        , srp0(1)
        , tvbc(5)
        , head1(11,[62,68, 46,2])
        , iy()
        , dh2(29)
        , dh1(8)
        ),

    'uni0E07':    #NGO NGU
        packline(""
        , mdapr(4)
        #
        , tgr_140(41,12,24)
        , xhead1(18,37,31)
        , add_ip(4,24,[0,9,3])
        , srp0(3)
        , tstemw_1(6)
        , ix()
        , dh1(21)
        , dh2(15)
        #y
        , sy()
        , mdapr(40)
        , tvtc2(21,[4,12,25])
        , head2(15,[28,34])
        , srp0(40)
        , tvbc(0)
        , tstemtc_1(9)
        , mdapr(4)
        , iy()
        , dh1(18)
        ),

    'uni0E08':    #CHO CHAN
        packline(""
        , mdapr(30)
        , mdrpg(29)
        #
        , tgr_140(53, 22,36)
        , tstemw_1(36)
        , mdrp0rg(3)
        , tstemw_1(15)
        , xhead1(9,49,43)
        , add_ip(3,36,[0,19])
        , add_ip(30,36,[26,33])
        , ix()
        , dh1(12)
        , dh2(6)
        #y
        , sy()
        , mdap(52)
        , tvtc2(33,[29,3,16,22,37,23,36])
        , tstemt_2(26)
        , mdrp0rg(12,"12-8 ")
        , head2(6,[40,46])
        , srp0(52)
        , tvbc(0)
        , tstemt_1(19)
        , mdapr(29)
        , iy()
        , dh1(9)
        ),

    'uni0E09':    #CHO CHING
        packline(""
        , mdapr(1,"9-8 10-8 11-8 12-8 13-8 ")
        , tstemw_1(14)
        , shprp2(0)
        , xhead1(7,51,45)
        , mdrprg(24)
        #
        , hr_no_nu(67, 16,31, 35,41,[63,57])
        , ix()
        , dh1(10)
        , dh2(4,38)
        #y
        , sy()
        , mdap(0)
        , tstemt_1(15)
        , tvtc2(27,[17,31,23])
        , tstemt_2(20)
        , mdapr(23)
        , mdrp0mrw(10)
        , head2(4,[42,48])
        , srp0(0)
        , tvbc(38)
        , head1(32,[54,60,41,16])
        , iy()
        , dh1(7)
        , dh2(35)
        ),

    'uni0E0A':    #CHO CHANG
        packline(""
        , hf_kho_khai(56, 19,10, 13, [53,47])
        , hr_cho_chang(57, 37,36, 28,30, 1,42, 4,25,40, 34)
        , dx(34,-8)
        , ix()
        , dh2(16)
        #y
        , sy()
        , mdap(1)
        , tstemt_1(43)
        , v_head_kho_khai(22,[2,42,38,36,4,25,40,34], 7, 10,16,[44,50],
            add1=mdrpmrg(30))
        , f_dstr(25,"14-3 15-3 16-3 ")
        , iy()
        , dh2(13)
        ),

    'uni0E0B':    #SO SO
        packline(""
        , hf_kho_khai(62, 23,12, 17, [59,53])
        , hr_cho_chang(63, 43,42, 34,36, 1,49, 4,31,46, 40)
        , add_ip(23,31, [26,27,28,7,8,9])
        , dx(40,-8)
        , ix()
        , dh1(14)
        , dh2(20)
        #y
        , sy()
        , mdap(1)
        , tstemt_1(49)
        , v_head_kho_khuat(28,26,[2,48,44,42,4,31,46,40], 7,9, 8,27, 14,20,[50,56],
            add1=mdrpmrg(36))
        , f_dstr(31,"14-3 15-3 16-3 ")
        , iy()
        , dh2(17)
        ),

    'uni0E0C':    #CHO_CHOE
        packline(""
        , hf_ko_kai(73, 34,22, 38,37, 20,18)
        , srp0(34)
        , xhead2(28,52,58)
        #
        #, hr_cho_choe(74, 46,1,48, 11,44, 8,2,[70,64])
        , tgr_160(74, 46,48)
        , alignrp(1)
        , ip_round(34,46,11)
        , tstemw_1(44)
        , ip_round(28,11,8,"13+8 ")
        , head1(2,[70,64])
        #
        , add_ip(38,44,[41,15])
        , ix()
        , dh1(25)
        , dh2(31,5)
        #y
        , sy()
        , mdap(1)
        , tstemt_1(46)
        , tvt2(48)
        , tvtc2(41,[35,37,38,18,19,20, 12,44])
        , tstemt_2(15)
        , srp0(1)
        , tvbc(31)
        , alignrp(5)
        , head1(25,[49,55,11,2],ss=45,l1s=61,l2s=67) 
        , f_dstr(2,"14+3 15+3 16+3 ")
        , iy()
        , dh1(8)
        , dh2(28)
        ),

    'base.uni0E0D.descless':    #YO YING
        packline(""
        , hf_ko_kai(51, 24,12, 28,27, 10,8)
        , srp0(24)
        , xhead2(18,42,48)
        #
        , tgr_160(52,36,38)
        , ip_round(24,36,1)
        , tstemw_1(34)
        #
        , add_ip(28,34,[31,5])
        , ix()
        , dh1(15)
        , dh2(21)
        #y
        , sy()
        , mdap(1)
        , tstemt_1(35)
        , tvt2(38)
        , tvtc2(31,[25,27,28, 8,9,10,12, 2,34])
        , tstemt_2(5)
        , srp0(1)
        , tvbc(21)
        , head1(15,[39,45])
        , iy()
        , dh2(18)
        ),

    'desc.uni0E0D':
        packline(""
        , mdapr(17)
        , mdrp0rg(4)
        , headsara1(10,[29,23])
        , ix()
        #y
        , sy()
        , mdap(32)
        , mdrp0mrw(7)
        , mdrprg(17)
        , headsara2(2,[20,26])
        , srp0(7)
        , mdrp0rg(0)
        , tstemt_sara_1(13)
        , iy()
        ),

    'uni0E0E':    #DO CHADA
        packline(""
        , hf_pho_samphao(76, 43,31, 38,63,57, 47,46, 29,27)
        , tgr_160(77, 20,53)
        , alignrp(1)
        , mdrprg(68)
        , f_ip([13,18,3])
        , mdrp0rg(8)
        , tstemw_sara_1(73)
        , add_ip(47,53,[50,24])
        , dx(68,8)
        , dx(18,-8)
        , ix()
        , dh1(41,11)
        , dh2(35,5)
        #y
        , sy()
        , mdap(76)
        , tvtc2(50,[44,46,47, 27,28,29,31, 21,53])
        , tstemt_2(24)
        , srp0(76)
        , tvbc(35)
        , head1(41,[54,60])
        , srp0(76)
        , tvblum(5)
        , alignrp(1)
        , tstemt_sara_1(66)
        , mdrp0rg(11)
        , f_ip([13,68,3,18,20])
        , tstemt_sara_2(70)
        , dx(3,8)
        , dx(13,-8)
        , iy()
        , dh1(38,8)
        ),

    'uni0E0F':    #TO PATAK
        packline(""
        , hf_pho_samphao(82, 49,37, 44,69,63, 53,52, 35,33)
        , tgr_160(83, 26,59)
        , alignrp(1)
        , mdrprg(74)
        , f_ip([16,21,23,24,2,3,6])
        , mdrp0rg(11)
        , tstemw_sara_1(80)
        , add_ip(53,59,[56,30])
        , dx(74,8)
        , dx(21,-8)
        , ix()
        , dh1(47,14)
        , dh2(41,8)
        #y
        , sy()
        , mdap(82)
        , tvtc2(56,[50,52,53, 33,34,35,37, 27,59])
        , tstemt_2(30)
        , srp0(82)
        , tvbc(41)
        , head1(47,[60,66])
        , srp0(82)
        , tvblum(8)
        , alignrp(4)
        , alignrp(1)
        , tstemt_sara_1(72)
        , mdrp0rg(14)
        , f_ip([16,11,23,24,2,6])
        , tstemt_sara_2(76)
        , dx(6,8)
        , dx(16,-8)
        , iy()
        , dh1(44,11)
        ),

    'base.uni0E10.descless':    #THO THAN
        packline(""
        , mdapr(26)
        , tstemw_1(48)
        #
        , srp0(65)
        , mdrpmrw(36)
        , add_ip(26,36,[29,42,39,32,22])
        , mdapr(22)
        , tstemw_1(48)
        , mdrp0rg(3)
        , tstemw_1(15)
        , xhead1(9,61,55)
        , ix()
        , dh1(12)
        , dh2(6)
        #y
        , sy()
        , mdapr(64)
        , v_top_ro_rua(29,[26,48,46,25,23,48,12], 42, 39,32,35,36)
        , mdapr(12)
        , head2(6,[52,58])
        , srp0(64)
        , tvbc(0)
        , tstemt_1(19)
        , iy()
        , dh1(9)
        ),

    'desc.uni0E10':
        packline(""
        , mdap(38)
        , tstemw_sara_2(26)
        , headsara2(32,[48,42])
        , mdrp0rg(21)
        , add_ip(21,26,[23,24,25,1,2,3,4])
        , headsara2(11,[58,53,16,6])
        , ix()
        #y
        , sy()
        , mdap(61)
        , mdrp0mrw(35)
        , headsara2(29,[39,45])
        , mdrp0rg(1)
        , alignrp(4)
        , alignrp(8)
        , tstemt_sara_1(26)
        , shprp2(23)
        , headsara1(14,[51,55])
        , iy()
        ),

    'uni0E11':    #THO NANGMONTHO
        packline(""
        , hf_kho_khai(59,30,19, 24, [56,50])
        , tgr_140(60,1,46)
        , add_ip(30,1,[8])
        , mdapr(8,"14+8 ")
        , add_ip(8,1,[42,7])
        , tstemw_1(40)
        , mdrp0rg(11)
        , tstemw_1(38)
        , srp0(42)
        , tstemw_sara_1(6)
        , add_ip(30,38, [33,34,35, 14,15,16])
        , ix()
        , dh1(21)
        , dh2(27)
        #y
        , sy()
        , mdap(1)
        , alignrp(7)
        , tstemt_1(41)
        , v_head_kho_khuat(35,33,[9,40,11,38,42,6,2,46], 14,16, 15,34, 21,27,[47,53], add1=pl( alignrp(44), tstemt_2(4)))
        , iy()
        , dh2(24)
        ),

    'uni0E12':    #THO PHUTHAO
        packline(""
        , hf_kho_khwai(80, 45,18, 39,38,23, 29,35,[65,59],
            ds5="9+8 17+8 18+8 ")
#
        , tgr_160(81, 53,55)
        , alignrp(1)
        , ip_round(39,53,11,"10+8 ")
        , tstemw_1(51)
        , ip_round(39,11,8)
        , head1(2,[77,71])
        , add_ip(45,51,[47,48,49,14,15,16])
        , ix()
        , dh1(32)
        , dh2(5)
        , f_dstr(27,ds_dryhead)
        #y
        , sy()
        , mdap(1)
        , alignrp(38)
        , tstemt_1(23)
        , shprp2(53)
        , tvt2(55)
        , v_top_kho_khon(49,47,[45,18,12,51], 14,16, 15,48, 32,26,[56,62])
        , srp0(1)
        , tvbc(5)
        , head1(11,[68,74,52,2])
        , f_dstr(2,"15+4 16+6 ")
        , iy()
        , dh1(29,8)
        , dh2(35)
        ),

    'uni0E13':    #NO NEN
        packline(""
        , hf_ko_kai(73, 24,12, 28,27, 10,8)
        , srp0(24)
        , xhead2(18,52,58)
        #
        , hr_no_nu(74,36,38, 42,48,[70,64])
        , srp0(36)
        , ip_round(24,36,1)
        , tstemw_1(34)
        , shprp2(0)
        , add_ip(28,34,[31,5])
        , ix()
        , dh1(15)
        , dh2(21,45)
        #y  
        , sy()
        , mdap(1)
        , tstemt_1(35)
        , tvt2(38)
        , tvtc2(31,[25,37,28,8,9,10,12,2,34])
        , tstemt_2(5)
        , srp0(1)
        , tvbc(21)
        , alignrp(45)
        , head1(15,[49,55,36,48], ss=39,l1s=61,l2s=67)
        , iy()
        , dh2(18,42)
        ),

    'uni0E14':    #DO DEK
        packline(""
        , hf_kho_khwai(54, 35,8, 29,28,13, 19,25,[51,45,16])
        , tgr_140(55, 1,41)
        , add_ip(35,41,[38,5])
        , ix()
        , dh1(22)
        , f_dstr(17,ds_dryhead)
        #y
        , sy()
        , mdap(1)
        , alignrp(28)
        , tstemt_1(13)
        , v_top_kho_khwai(38,[35,8,2,41],5,22,16,[42,48])
        , iy()
        , dh1(19)
        , dh2(25)
        ),

    'uni0E15':    #TO TAO
        packline(""
        , hf_kho_khwai(54, 35,8, 29,28,13, 19,25,[51,45,16])
        , tgr_140(55, 1,41)
        , add_ip(35,41,[37,38,39,4,5,6])
        , ix()
        , dh1(22)
        , f_dstr(17,ds_dryhead)
        #y
        , sy()
        , mdap(1)
        , alignrp(28)
        , tstemt_1(13)
        , v_top_kho_khon(39,37,[35,8,2,41], 4,6, 5,38, 22,16,[42,48])
        , iy()
        , dh1(19)
        , dh2(25)
        ),

    'uni0E16':      #THO THUNG
        packline(""
        , hf_ko_kai(47, 24,12, 28,27, 10,8)
        , srp0(24)
        , xhead2(18,38,44)
        , tgr_140(48,1,34)
        , ix()
        , dh1(15)
        , dh2(21)
        #y
        , sy()
        , mdap(1)
        , tvtc2(31,[25,27,28,8,9,10,12,2,34])
        , tstemt_2(5)
        , srp0(1)
        , tvbc(21)
        , head1(15,[35,41])
        , iy()
        , dh2(18)
        ),

    'uni0E17':      #THO THAHAN
        packline(""
        , hf1(43, 10,22, 16,40,34, s2s=9)
        , tgr_140(44, 1,30)
        , add_ip(10,30,[8])
        , srp0(8)
        , tstemw_sara_2(24)
        , ix()
        , dh1(19)
        , dh2(13)
        #y
        , sy()
        , mdap(1)
        , alignrp(9)
        , tvtc2(19,[23,24,8,2,30])
        , alignrp(27)
        , tstemt_2(5)
        , head2(13,[31,37])
        , f_dstr(23,"14-4 15-5 16-6 ")
        , iy()
        , dh1(16)
        ),

    'uni0E18':      #THO THONG
        packline(""
        , mdap(9,"19+8 ")
        , tstemw_1(28)
        , mdrp0rg(1,"21-8 22-8 23-8 ")
        , tstemw_1(3)
        #
        , srp0(33)
        , mdrp0mrw(19)
        , tgr_160(33,5,31)
        , add_ip(9,19,[12,25,22,15])
        , ix()
        #y
        , sy()
        , mdap(1)
        , tstemt_1(4)
        , v_top_ro_rua(12,[9,28,29,8,6,31,2], 25,22,15,18,19)
        , mdapr(2)
        , iy()
        ),

    'uni0E19':      #NO NU
        packline(""
        , hf1(52,1,13,7,37,31, s2s=0)
        , hr_no_nu(53, 15,17, 21,27,[49,43])
        , ix()
        , dh1(10)
        , dh2(24,4)
        #y
        , sy()
        , mdap(0)
        , tstemt_1(14)
        , tvt2(17)
        , tvtc2(10)
        , head2(4,[28,34])
        , srp0(0)
        , tvbc(24)
        , head1(18,[40,46,15,27])
#        , f_dstr(27,"15+4 16+4 ")
        , iy()
        , dh1(7)
        , dh2(21)
        ),  

    'uni0E1A':      #BO BAIMAI
        packline(""
        , hf1(30, 1,13,7,27,21)
        , tgr_160(31, 15,17)
        , ix()
        , dh1(10)
        , dh2(4)
        #y  
        , sy()
        , mdap(1)
        , tstemt_1(14)
        , tvt2(17)
        , tvtc2(10)
        , head2(4,[18,24])
        , iy()
        , dh1(7)
        ),

    'uni0E1B':      #PO PLA
        packline(""
        , hf1(30, 1,13,7,27,21)
        , tgr_160(31, 15,17)
        , ix()
        , dh1(10)
        , dh2(4)
        #y  
        , sy()
        , mdap(1)
        , tstemt_1(14)
        , tvtpo(17)
        , tvtc2(10)
        , head2(4,[18,24])
        , iy()
        , dh1(7)
        ),

    'uni0E1C':      #PHO PHUNG
        packline(""
        , tgf_148(35,4,16)
        , shprp2(3)
        , xhead2(11,26,32)
        #
        , tgr_160(36,20,22)
        , add_ip(4,22,[3,2,1,18,19,2])
        , ix()
        , dh1(8)
        , dh2(14)
        #y  
        , sy()
        , mdap(1)
        , alignrp(3)
        , tvt2(22)
        , tvtc2(8,[17])
        , head2(14,[23,29])
        , add_ip(14,1,[18,2])
        , f_dstr(17,"14-4 15-5 16-6 ")
        , srp0(17)
        , alignrp(20)
        , iy()
        , dh2(11)
        ),  

    'uni0E1D':      #FO FA
        packline(""
        , tgf_148(35,4,16)
        , shprp2(3)
        , xhead2(11,26,32)
        #
        , tgr_160(36,20,22)
        , add_ip(4,22,[3,2,1,18,19,2])
        , ix()
        , dh1(8)
        , dh2(14)
        #y  
        , sy()
        , mdap(1)
        , alignrp(3)
        , tvtpo(22)
        , tvtc2(8,[17])
        , head2(14,[23,29])
        , add_ip(14,1,[18,2])
        , f_dstr(17,"14-4 15-5 16-6 ")
        , srp0(17)
        , alignrp(20)
        , iy()
        , dh2(11)
        ),  

    'uni0E1E':      #PHO PHAN
        packline(""
        , hf1(35,4,16,10,32,26,s2s=3)
        , tgr_160(36,20,22)
        , alignrp(1)
        , add_ip(16,20,[18,19,2])
        , ix()
        , dh1(13)
        , dh2(7)
        #y
        , sy()
        , mdap(1)
        , alignrp(3)
        , tvt2(22)
        , tvtc2(13,[2,17,18,19,20])
        , head2(7,[23,29])
        , iy()
        , dh1(10)
        , f_dstr(2,"14+3 15+3 16+6 ")
        ),

    'uni0E1F':      #FO FAN
        packline(""
        , hf1(35,4,16,10,32,26,s2s=3)
        , tgr_160(36,20,22)
        , alignrp(1)
        , add_ip(16,20,[18,19,2])
        , ix()
        , dh1(13)
        , dh2(7)
        #y
        , sy()
        , mdap(1)
        , alignrp(3)
        , tvtpo(22)
        , tvtc2(13,[2,17,18,19,20])
        , head2(7,[23,29])
        , iy()
        , dh1(10)
        , f_dstr(2,"14+3 15+3 16+6 ")
        ),

    'uni0E20':    #PHO SAMPHAO
        packline(""
        , hf_pho_samphao(47, 24,12, 19,44,38, 28,27, 10,8)
        , tgr_160(48,1,34)
        , add_ip(28,34,[31,5])
        , ix()
        , dh1(22)
        , dh2(16)
        #y
        , sy()
        , mdap(1)
        , tvtc2(31,[25,27,28, 8,9,10,12, 2,34])
        , tstemt_2(5)
        , srp0(1)
        , tvbc(16)
        , head1(22,[35,41])
        , iy()
        , dh1(19)
        ),

    'uni0E21':      #MO MA
        packline(""
        , hf1(54, 13,25,19,39,33,s2s=2,s3s=8,s4s=51,s5s=45)
        , tgr_160(55, 27,29)
        , alignrp(1)
        , ix()
        , dh1(22,11)
        , dh2(16,5)
        #y
        , sy()
        , mdap(1)
        , tstemt_1(27)
        , tvt2(29)
        , tvtc2(22)
        , head2(16,[30,36])
        , srp0(1)
        , tvbc(5)
        , head1(11,[42,48,26,2])
        , iy()
        , dh1(19,8)
        , f_dstr(2,"14+3 15+3 16+3 ")
        ),
    
    'uni0E22':    #YO YAK
        packline(""
        , mdapr(1,"9-8 10-8 11-8 ")
        , alignrp(8)
        , tstemw_1(27)
        , shprp2(19)
        , mdrprg(24)
        , f_ip([5])
        , xhead2(14,35,41,dstr="12-8 13-8 15-8 16-8 23-8 ")
        #
        , tgr_160(45,29,31)
        , ix()
        , dh1(11)
        , dh2(17)
        #y
        , sy()
        , mdap(1)
        , tstemt_1(28)
        , tvt2(31)
        , tvtc2(11)
        , head2(17,[32,38,19])
        , mdrp0mrg(23)
        , tstemt_2(24)
        , f_ip([5])
        , iy()
        , dh2(14)
        ),

    'uni0E23':    #RO RUA
        packline(""
        , mdapr(12)
        , tstemw_1(31)
        , srp0(51)
        , mdrp0mrw(22)
        , add_ip(12,22,[15,28,25,18,8])
        , mdapr(8)
        , tstemw_1(34)
        , xhead1(3,47,41)
        , ix() 
        , dh1(6)
        , dh11(1), dh12(37)
        #y
        , sy() 
        , mdap(50)
        , v_top_ro_rua(15,[12,31,32,11,9,34], 28, 25,18,21,22)
        , srp0(50)
        , tvbc(0)
        , head1(6,[38,44])
        , iy()
        , dh1(3)
        ),  

    'uni0E24':      #RU
        packline(""
        , hf_ko_kai(47, 24,12, 28,27, 10,8)
        , srp0(24)
        , xhead2(18,38,44)
        , tgr_140(48,1,34)
        , ix()
        #y
        , sy()
        , mdap(47)
        , tvtc2(31,[25,27,28,8,9,10,12,2,34])
        , tstemt_2(5)
        , srp0(47)
        , tvbc(21)
        , head1(15,[35,41])
        , srp0(47)
        , tvblu(1)
        , iy()
        , dh2(18)
        ),

    'uni0E25':      #LO LING
        packline(""
        , tgf_162(54,20,8)
        , mdrprg(35)
        , xhead2(14,45,51)
        #
        , tgr_140(55,1,41)
        , alignrp(27)
        , add_ip(7,27,[24,5])
        , add_ip(35,41,[38,31])
        , ix()
        , dh1(11)
        , dh2(17)
        #y
        , sy()
        , mdap(1)
        , tvtc2(38,[21,8,28,41,7,24,34])
        , tstemt_2(31)
        , mdapr(34)
        , mdapr(24)
        , tstemt_2(5)
        , srp0(1)
        , tvbc(17)
        , head1(11,[42,48])
        , iy()
        , dh2(14)
        ),

    'uni0E26':    #LU
        packline(""
        , hf_pho_samphao(47, 24,12, 19,44,38, 28,27, 10,8)
        , tgr_160(48,1,34)
        , add_ip(28,34,[31,5])
        , ix()
        , dh1(22)
        , dh2(16)
        #y
        , sy()
        , mdap(47)
        , tvtc2(31,[25,27,28, 8,9,10,12, 2,34])
        , tstemt_2(5)
        , srp0(47)
        , tvbc(16)
        , head1(22,[35,41])
        , srp0(47)
        , tvblu(1)
        , iy()
        , dh1(19)
        ),

    'uni0E27':    #WO WAEN
        packline(""
        , mdapr(16)
        , tgr_140(39,8,22)
        , xhead1(3,35,29)
        , add_ip(16,22,[19,12])
        , ix()
        , dh1(6)
        , dh11(1), dh12(23)
        #y
        , sy()
        , mdap(38)
        , tvtc2(19,[9,22,15])
        , tstemt_2(12)
        , mdapr(15)
        , srp0(38)
        , tvbc(0)
        , head1(6,[26,32])
        , iy()
        , dh1(3)
        ),  

    'uni0E28':    #SO SALA
        packline(""
        , hf_kho_khwai(67, 42,14, 36,35,17, 20,26,[64,58,32])
        , tgr_140(68,1,54)
        , mdrp0rg(49)
        , mdrpg(50)
        , add_ip(42,54,[45,11,9,47,4,52])
        , dx(9,8)
        , dx(52,-8)
        , ix()
        , dh1(23)
        , dh2(29)
        #y
        , sy()
        , mdap(1)
        , alignrp(35)
        , v_top_kho_khwai(45,[42,14,2,54,47,9,52,4,17], 11, 23,29,[55,61,32,20],add1=mdrpmrg(50))
        , dx(32,8)
        , dx(17,-16)
        , dx(4,8)
        , dx(47,-8)
        , iy()
        , dh2(26)
        , f_dstr_dict({47:"14-4 15-4 16-4 ", 4:"14+4 15+4 16+4 "})
        ),

    'uni0E29':      #SO RUSI
        packline(""
        , hf1(65, 1,13,7,50,44)
        #
        , tgr_160(66, 15,40)
        , alignrp(32)
        , shprp2(34)
        , mdrp0mrw(27)
        , mdrprg(21)
        , f_ip([62,56,30])
        , ix()
        , dh1(10,24)
        , dh2(4)
        #y  
        , sy()
        , mdap(1)
        , tstemt_1(14)
        , tvt2(34)
        , tvtc2(10,[24])
        , head2(4,[41,47])
        , mdapr(24)
        , mdrp0rg(18)
        , f_ip([53,59,30,32,16,40,35])
        , dx(16,8)
        , dx(35,-8)
        , iy()
        , dh1(7,21)
        ),

    'uni0E2A':      #SO SUA
        packline(""
        , tgf_162(66,20,8)
        , mdrprg(41)
        , xhead2(14,57,63)
        #
        , tgr_140(67,1,53)
        , alignrp(27)
        , mdrp0rg(48)
        , mdrpg(49)
        , add_ip(8,27,[24,5])
        , add_ip(41,53,[44,37,35,46,51,30])
        , dx(35,8)
        , dx(51,-8)
        , ix()
        , dh1(11)
        , dh2(17)
        #y
        , sy()
        , mdap(1)
        , tvtc2(44,[21,8,28,53,8,24,40,27])
        , mdrpmrg(49)
        , tstemt_2(37)
        , mdapr(40)
        , mdapr(24)
        , tstemt_2(5)
        , srp0(1)
        , tvbc(17)
        , head1(11,[54,60])
        , dx(30,8)
        , dx(46,-8)
        , iy()
        , dh2(14)
        , f_dstr_dict({46:"14-4 15-4 16-4 ", 30:"14+4 15+4 16+4 "})
        ),

    'uni0E2B':      #HO HIP
        packline(""
        , hf1(61, 8,20, 14,46,40, s2s=7)
        , tgr_140(62, 1,36)
        , mdrp0rg(32)
        , head2(26,[58,52,24,34,4])
        , add_ip(8,36,[6])
        , srp0(6)
        , tstemw_sara_2(22)
        , f_dstr(26,"9-8 ")
        , ix()
        , dh1(17,29)
        , dh2(11)
        #y
        , sy()
        , mdap(1)
        , alignrp(7)
        , tvtc2(17,[21,22,6,2,36])
        , alignrp(29)
        , head2(11,[37,43],l1s=49,l2s=55)
        , srp0(49)
        , tstemt_2(4)
        , f_ip([24,34])
        , f_dstr(21,"14-4 15-5 16-6 ")
        , iy()
        , dh1(14,26)
        , dh2(32)
        ),

    'uni0E2C':      #LO CHULA
        packline(""
        , hf1(64, 4,16,10,49,43,s2s=3)
        , tgr_160(65, 20,39)
        , alignrp(1)
        , xhead1(26,61,55)
        , add_ip(16,20,[18,19,2])
        , ix()
        , dh1(13,29)
        , dh2(7,23)
        #y
        , sy()
        , mdap(1)
        , alignrp(3)
        , tvtc2(13,[2,17,18,19,20])
        , head2(7,[40,46])
        , srp0(1)
        , mirp0rg("ecvheight_shoot",29)
        , head2(23,[52,58,39,32])
        , iy()
        , dh1(10,26)
        , f_dstr(2,"14+3 15+3 16+6 ")
        ),

    'uni0E2D':      #O ANG
        packline(""
        , tgf_162(42,1,13)
        , mdrprg(23)
        , xhead2(8,33,39)
        #
        , tgr_140(43,15,29)
        , add_ip(23,29,[26,19])
        , ix()
        , dh1(5)
        , dh2(11)
        #y
        , sy()
        , mdap(1)
        , tstemt_1(14)
        , tvtc2(26,[22,16,29])
        , tstemt_2(19)
        , mdapr(22)
        , mdrp0mrw(5)
        , head2(11,[30,36])
        , iy()
        , dh2(8)
        ),  

    'uni0E2E':      #HO NOKHUK
        packline(""
        , mdapr(1,"9-8 10-8 11-8 ")
        , alignrp(23)
        , tstemw_1(13)
        , xhead2(8,39,45)
        , srp0(23)
        , tstemw_1(55)
        #
        , tgr_140(58,15,35)
        , add_ip(23,35,[26,52,48,20,50,28,33,18])
        , dx(50,24)
        , dx(33,-16)
        , ix()
        , dh1(5)
        , dh2(11)
        #y
        , sy()
        , mdap(1)
        , tstemt_1(14)
        , tvtc2(26,[16,35])
        , tstemt_2(52)
        , mdrp0rg(20)
        , f_ip([28,50,33,18])
        , tstemt_sara_1(48)
        , mdrp0mrw(5)
        , head2(11,[36,42])
        , iy()
        , dh2(8)
        ),

    'uni0E2F':      #PAIYAN NOI
        packline(""
        , tgr_160(37,1,23)
        , alignrp(22)
        , mdrp0rg(8)
        , f_ip([5,19])
        , head1(14,[33,27,17])
        , ix()  
        , dh1(11)
        #y  
        , sy()
        , mdap(1)
        , tvt2(23)
#        , tvtc2(11,[2])
, tvtc2(11)
        , head2(17,[24,30])
        , mdrp0rg(19)
        , tstemt_2(5)
        , iy()
        , dh2(14)
        ),  

    'uni0E30':      #SARA A
        packline(""
        , mdap(3,"9-8 10-8 11-8 ")
        , alignrp(33)
        , mdrprg(15)
        , shprp2(45)
        , head1(9,[27,21],ss=39,l1s=57,l2s=51)
        , ix()
        , dh1(36,6)
        #y  
        , sy()
        , mdapr(0)
        , tstemt_1(11)
        , xhead2(6,24,18,dstr="11-8 16-8 ")
        , mdrprg(14)
        #
        , mdapr(30,"11+8 ")
        , tstemt_1(41)
        , xhead2(36,54,48,dstr="11-8 16-8 ")
        , mdrprg(44)
        , iy()
        , dh1(3,33)
        , dh2(39,9)
        ),

    'uni0E31':      #MAI HAN-AKAT
        packline(""
        , mdap(3)
        , mdrprg(15)
        , head1(9,[27,21])
        , ix()
        , dh1(6)
        #y  
        , sy()
        , tvtsara(0)
        , tstemt_1(11)
        , xhead2(6,24,18)
        , mdrprg(14)
        , iy()
        , dh1(3)
        , dh2(9)
        ),

    'uni0E32':    #SARA AA
        packline(""
        , mdapr(9)
        , tgr_140(16,1,15)
        , add_ip(9,15,[12,5])
        , ix()
        #y
        , sy()
        , mdap(1)
        , tvtc2(12,[8,2,15])
        , tstemt_2(5)
        , mdapr(8)
        , iy()
        ),  

    'uni0E34':    #SARA I
        packline(""
        , mdap(0)
        , tstemw_2(9)
        , mdrp0rg(3)
        , tstemw_1(15)
        , ix()
        #y
        , sy()
        , tvtsara(0)
        , mirp0rg("tstemw",15)
        , f_ip([3,9])
        , mdrp0rw(12)
        , tstemw_sara_1(6)
        , iy()
        ),
    
    'uni0E35':    #SARA II
        packline(""
        , mdap(0)
        , tstemw_2(12)
        , tstemtc_2(10)
        , mdrp0rg(3)
        , tstemw_1(18)
        , ix()
        #y
        , sy()
        , tvtsara(0)
        , mirp0rg("tstemw",18)
        , f_ip([3,12])
        , mdrp0rw(15)
        , tstemw_sara0_1(6)
        , mdrpmrg(11)
        , mdapr(11)
        , iy()
        ),
    
    'uni0E36':    #SARA UE
        packline(""
        , mdap(0)
        , tstemw_2(19)
        , mdrp0mrg(14)
        , headsara2(8,[37,31])
        , srp0(0)
        , mdrp0rg(3)
        , tstemw_1(25)
        , ix()
        #y
        , sy()
        , tvtsara(0)
        , mirp0rg("tstemw",25)
        , f_ip([3,19])
        , mdrp0mrg(22)
        , tstemw_sara0_1(6)
        , mdrp0rw(11)
        , mdapr(11)
        , headsara2(17,[28,34])
        , iy()
        ),

    'uni0E37':    #SARA UUE
        packline(""
        , mdap(0)
        , tstemw_2(16)
        , tstemt0_2(14)
        , mdrp0mrg(11)
        , mdapr(11)
        , tstemt_2(9)
        , srp0(0)
        , mdrp0rg(3)
        , tstemw_1(22)
        , ix()
        #y  
        , sy()   
        , tvtsara(0)
        , mirp0rg("tstemw",22)
        , f_ip([3,16])
        , mdrp0rw(19)
        , f_ip([11,13])
        , tstemw_sara0_1(6)
        , mdrpmrg(10)
        , mdapr(10)
        , shprp2(15)
        , iy()
        ),  

    'uni0E38':    #SARA U
        packline(""
        , mdapr(13)
        , tstemw_sara_2(1)
        , mdrpmrg(7)
        , f_ip([23,17])
        , ix()
        #y  
        , sy()
        , mdap(26) 
        , mdrp0mrw(10)
        , head_sara0_2(4)
        , f_ip([14,20])
        , mdrpmrg(1)
        , iy()
        ),  

    'uni0E39':    #SARA UU
        packline(""
        , mdap(17)
        , tstemw_sara0_2(15)
        , mdrp0mrw(13)
        , mdapr(13)
        , tstemw_sara_2(1)
        , mdrpmrg(7)
        , f_ip([27,21])
        , ix() 
        #y  
        , sy()
        , mdap(30)
        , mdrp0mrw(10)
        , mdrprg(17)
        , mdrp0rg(4)
        , alignrp(14)
        , f_ip([24,18])
        , tstemt_sara_2(1)
        , iy()
        ),

    'uni0E3A':    #PHINTHU
        packline(""
        , mdap(9)
        , mdrpmrg(3)
        , ix() 
        #y  
        , sy()
        , mdap(12)
        , mdrp0mrw(6)
        , mdrpmrg(0)
        , iy() 
        ),

#    'uni0E3F':    #THAI CURRENCY SYMBOL BAHT
#        packline(""
#        , mdap(9,"11-8 12-8 13-8 14-8 ")
#        , tstemw_1(54)
#        , shprp2(50)
#        , mdrprg(6)
#        , shprp2(13)
#        #
#        , mdrp0rg(52,"11+8 ")
#        , alignrp(48)
#        , alignrp(2)
#        , alignrp(16)
#        , tstemw_1(64)
#        , shprp2(47)
#        , shprp2(36)
#        , shprp2(21)
#        #
#        , mdrp0rg(60)
#        , f_ip([29])
#        , tstemw_1(32)
#        , mdrp0rg(43,"12+8 ")
#        , tstemw_1(26)
#        , ix() 
#        #y  
#        , sy()
#        , mdap(3)
#        , alignrp(36)
#        , mdrprg(0)
#        , tstemt_1(52)
#        , shprp2(56)
#        , shprp2(9)
#        #
#        , mdrp0rg(53)
#        , f_ip([60,32])
#        , alignrp(64)
#        , tstemt_1(48)
#        , f_ip([29])
#        , shprp2(39)
#        #
#        , mdrp0rg(16)
#        , f_ip([43,26])
#        , alignrp(22)
#        , mdrprg(19)
#        , tstemt_2(49)
#        , shprp2(10)
#        , shprp2(47)
#        , iy() 
#        ), 
#
#MODIFY AUTO-INSTUCTION: uni0E3F
    'uni0E3F':    #THAI CURRENCY SYMBOL BAHT
        """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   3 1 0     ;PUSH Bytes
CALL            0 1 3      ;CALL function
                           #--- PUSHB_1   21        ;PUSH Bytes
SHP[rp1]        21         ;SHift Point using reference point
                           #--- PUSHB_2   26 13     ;PUSH Bytes
MIRP[min,black] ecstemt 26 ;Move Indirect Relative Point
                           #--- PUSHB_1   27        ;PUSH Bytes
SHP[rp2]        27         ;SHift Point using reference point
                           #--- PUSHB_3   3 26 10   ;PUSH Bytes
CALL            10 26 3    ;CALL function
                           #--- PUSHB_4   64 3 0 9  ;PUSH Bytes
CALL            9 0 3 64   ;CALL function
                           #--- PUSHB_1   25        ;PUSH Bytes
MDAP[rnd]       25         ;Move Direct Absolute Point
                           #--- PUSHB_1   33        ;PUSH Bytes
SHP[rp1]        33         ;SHift Point using reference point
                           #--- PUSHB_2   39 13     ;PUSH Bytes
MIRP[min,black] ecstemt 39 ;Move Indirect Relative Point
                           #--- PUSHB_1   40        ;PUSH Bytes
SHP[rp2]        40         ;SHift Point using reference point
                           #--- PUSHB_1   38        ;PUSH Bytes
MDAP[rnd]       38         ;Move Direct Absolute Point
                           #--- PUSHB_1   46        ;PUSH Bytes
SHP[rp1]        46         ;SHift Point using reference point
                           #--- PUSHB_2   4 13      ;PUSH Bytes
MIRP[min,black] ecstemt 4  ;Move Indirect Relative Point
                           #--- PUSHB_1   8         ;PUSH Bytes
SHP[rp2]        8          ;SHift Point using reference point
                           #--- PUSHB_3   4 38 10   ;PUSH Bytes
CALL            10 38 4    ;CALL function
                           #--- PUSHB_4   64 4 7 9  ;PUSH Bytes
CALL            9 7 4 64   ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   49        ;PUSH Bytes
MDAP[rnd]       49         ;Move Direct Absolute Point
                           #--- PUSHB_1   3         ;PUSH Bytes
MDRP[rp0,rnd,white] 3          ;Move Direct Relative Point
f_deltap 3 9-8
                           #--- PUSHB_2   26 16     ;PUSH Bytes
MIRP[min,black] estemw 26  ;Move Indirect Relative Point
                           #--- PUSHB_1   38        ;PUSH Bytes
SHP[rp2]        38         ;SHift Point using reference point
                           #--- PUSHB_1   26        ;PUSH Bytes
SRP0            26         ;Set Reference Point 0
                           #--- PUSHB_2   1 1       ;PUSH Bytes
CALL            1 1        ;CALL function
                           #--- PUSHB_3   5 23 36   ;PUSH Bytes
SHP[rp2]        36         ;SHift Point using reference point
SHP[rp2]        23         ;SHift Point using reference point
SHP[rp2]        5          ;SHift Point using reference point
                           #--- PUSHB_5   0 15 0 71 4 ;PUSH Bytes
CALL            4 71 0 15 0 ;CALL function
                           #--- PUSHB_3   7 34 47   ;PUSH Bytes
SHP[rp2]        47         ;SHift Point using reference point
SHP[rp2]        34         ;SHift Point using reference point
SHP[rp2]        7          ;SHift Point using reference point
                           #--- PUSHB_1   0         ;PUSH Bytes
SRP0            0          ;Set Reference Point 0
                           #--- PUSHB_2   30 1      ;PUSH Bytes
CALL            1 30       ;CALL function
                           #--- PUSHB_2   18 16     ;PUSH Bytes
MIRP[min,black] estemw 18  ;Move Indirect Relative Point
                           #--- PUSHB_1   43        ;PUSH Bytes
                           #--- DUP       #43       ;DUPlicate top stack element
MDRP[rp0,rnd,white] 43         ;Move Direct Relative Point
SRP1            43         ;Set Reference Point 1
                           #--- PUSHB_2   12 16     ;PUSH Bytes
MIRP[min,black] estemw 12  ;Move Indirect Relative Point
                           #--- PUSHB_2   50 1      ;PUSH Bytes
CALL            1 50       ;CALL function
                           #--- PUSHB_2   43 0      ;PUSH Bytes
SRP1            0          ;Set Reference Point 1
SRP2            43         ;Set Reference Point 2
                           #--- PUSHB_1   15        ;PUSH Bytes
IP              15         ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   25 26     ;PUSH Bytes
SRP1            26         ;Set Reference Point 1
SRP2            25         ;Set Reference Point 2
                           #--- PUSHB_1   18        ;PUSH Bytes
IP              18         ;Interpolate Point
                           #--- PUSHB_1   39        ;PUSH Bytes
SRP1            39         ;Set Reference Point 1
                           #--- PUSHB_1   15        ;PUSH Bytes
IP              15         ;Interpolate Point
                           #--- PUSHB_1   38        ;PUSH Bytes
SRP2            38         ;Set Reference Point 2
                           #--- PUSHB_1   12        ;PUSH Bytes
IP              12         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
        """,

    'uni0E40':    #SARA E
        packline(""
        , mdap(3)
        , tstemw_1(5)
        , xhead2(11,17,23)
        , ix()
        , dh1(8)
        , dh11(1), dh12(13)
        #y  
        , sy()
        , mdap(26)
        , tvt2(5)
        , tvbc(0)
        , head1(8,[14,20])
        , iy()
        , dh2(11)
        ),

    'uni0E42':    #SARA O
        packline(""
        , mdap(3)
        , tstemw_1(33)
        , xhead2(39,45,51)
        , srp0(3)
        , mdrp0rg(7)
        , tstemw_1(30)
        , mdrprg(19)
        , f_ip([10,27,15,22])
        , ix()
        , dh1(36)
        , dh11(1), dh12(41)
        #y  
        , sy()
        , mdap(54)
        , tvbc(0)
        , head1(36,[42,48])
        #
        , mdap(10)
        , tstemt_2(27)
        , mdrp0rg(22,"9-4 10-4 11-4 12+4 13+4 ")
        , tstemt_1(15)
        , add_ip(10,0,[7,30,6,31,4,33])
        , iy()   
        , dh2(39)
        ),

    'uni0E43':    #SARA AI MAI MUAN
        packline(""
        , mdap(3)
        , tstemw_1(34)
        , xhead2(40,46,52)
        , mdapr(23)
        , headstem_1(64)
        , mdrp0rg(17)
        , headstem_2(58)
        , mdrp0mrw(9)
        , tstemw_1(29)
        , ix()
        , dh1(37)
        , dh2(20)
        , dh11(1), dh12(42)
        #y  
        , sy()
        , mdap(67)
        , tvbc(0) 
        , head1(37,[43,49])
        #
        , mdap(26)
        , tstemt0_2(12)
        , mdrp0rg(14,"11+8 12+8 13+8 14+8 15+8 16+8 ")
        , headstem_2(61)
        , mdrp0rg(20,"11-8 15-8 16-8 ")
        , headstem_1(55)
        , iy()
        , dh2(17,40)
        ),

    'uni0E44':    #SARA AI MAIMALAI
        packline(""
        , mdap(3)
        , tstemw_1(27)
        , xhead2(33,39,45)
        , srp0(3)
        , mdrprg(15)
        , f_ip([16,19,12,21,9,24,7])
        , ix()
        , dh1(30)
        , dh11(1), dh12(35)
        #y  
        , sy()
        , mdap(48)
        , tvbc(0)
        , head1(30,[36,42])
        #
        , mdap(24)
        , tstemtc_2(7)
        , mdrprg(16)
        , mdrp0rg(12)
        , tstemt_1(19)
        , iy()
        , dh2(33)
        ),

    'uni0E45':    #LAKKHANGYAO
        packline(""
        , mdapr(9)
        , tgr_160(16,1,15)
        , add_ip(9,15,[12,5])
        , ix()
        #y
        , sy()
        , mdap(16)
        , tvtc2(12,[8,2,15])
        , tstemt_2(5)
        , mdapr(8)
        , srp0(16)
        , tvblu(1)
        , iy()
        ),

    'uni0E46':    #MAIYAMOK
        packline(""
        , mdapr(1,"9-8 13+8 ")
        , tstemw_1(25)
        , mdrp0rg(19)
        , head1(13,[35,29])
        , add_ip(19,25,[21,22,23,4,5,6])
        , ix()
        , dh1(10)
        , dh2(16)
        #y
        , sy()
        , mdap(38)
        , tvtc2(21,[2,25])
        , alignrp(23)
        , tstemt_2(6)
        , shprp2(4)
        , mdrp0rg(5,"9-8 10-8 12-3 13-3 14-3 15-3 16-3 17-3 ")
        , tstemt_1(22)
        , mdrp0rg(10)
        , mdapr(10)
        , head2(16,[26,32])
        #
        , srp0(38)
        , tvblu(1)
        , iy()
        , dh2(13)
        ),

    'uni0E47':    #MAITAIKHU
        packline(""
        , mdap(41)
        , mdrprg(17)
        , mdrprg(35,"10-8 16+8 ")
        , f_ip([53,47])
        , mdrp0rg(10)
        , f_ip([26,29,5,3])
        , tstemw_sara_1(23)
        , ix()
        #y
        , sy()
        , tvtsara(0)
        , alignrp(7)
        , tstemt_sara_1(26)
        , mdrprg(38,"9-4 10-4 15-8 16-8 ")
        , f_ip([44,50,32,3,29])
        , mdrp0mrg(20)
        , tstemt_sara0_1(13)
        , mdrpmrg(16)
        , iy()
        ),

    'base.uni0E47.high':    #MAITAIKHU
        packline(""
        , mdap(41)
        , mdrprg(17)
        , mdrprg(35)
        , f_ip([53,47])
        , mdrp0rg(10)
        , f_ip([23,26,29,5,3])
        , ix()
        #y
        , sy()
        , tvtwanayuk(0)
        , alignrp(7)
        , mdrprg(38)
        , f_ip([44,50,32,3,29,26])
        , mdrprg(13)
        , f_ip([20])
        , iy()
        ),

    'uni0E48':    #MAI EK
        packline(""
        , mdap(0)
        , tstemt_2(1)
        , ix()
        #y
        , sy()
        , tvtwanayuk(0)
        , mdrpmg(3)
        , iy()
        ),

    'base.uni0E48.low':    #MAI EK
        packline(""
        , mdap(0)
        , tstemw_2(1)
        , ix()
        #y
        , sy()
        , tvtsara(0)
        , mdrpmg(3)
        , iy()
        ),

    'uni0E49':    #MAI THO
        packline(""
        , mdap(15)
        , mdrprg(22)
        , mdrprg(2)
        , f_ip([9,34,28,6,18])
        , ix()
        #y
        , sy()
        , tvtwanayuk(0)
        , mdrp0rg(6)
        , f_ip([3,18])
        , mdrp0rg(12)
        , f_ip([31,25,21])
        , iy()
        ),

    'base.uni0E49.low':    #MAI THO
        packline(""
        , mdap(15)
        , mdrprg(22)
        , headsara2(9,[34,28,6,18])
        , mdrprg(2)
        , ix()
        , dh1(12)
        , f_dstr_dict({19:"15+5 16+5 ", 7:"15+6 16+6 "}) 
        #y
        , sy()
        , tvtsara(0)
        , tstemt_sara_1(3)
        , shprp2(18)
        , mdrp0rg(6)
        , mdrprg(21)
        , headsara1(12,[25,31])
        , iy()
        , dh1(9)
        , dh2(15)
        ),

    'uni0E4A':    #MAI TRI
        packline(""
        , mdap(29)
        , tstemt_sara_2(4)
        , mdrprg(37)
        , mdrp0rg(21)
        , f_ip([24,25,26,6,7,8])
        , tstemt_sara_2(10)
        , mdrprg(15,"12-8 ")
        , f_ip([50,44])
        , ix()
        #y
        , sy()
        , tvtwanayuk(1)
        , alignrp(18)
        , tstemt_sara_1(2)
        , shprp2(32)
        , mdrprg(12,"11-8 12-8 13-8 14-8 16-8 ")
        , f_ip([41,47])
        , mdrp0rg(24)
        , alignrp(26)
        , mdrprg(36)
        , tstemt_sara_2(8)
        , shprp2(6)
        , iy()
        , dx(25,-16)
        ),

    'base.uni0E4A.low':    #MAI TRI
        packline(""
        , mdap(29)
        , tstemw_sara_2(4)
        , mdrprg(37)
        , mdrp0rg(21)
        , f_ip([24,25,26,6,7,8])
        , tstemw_sara_2(10)
        , mdrprg(15,"15-8 16-8 ")
        , f_ip([50,44])
        , ix()
#        , dh1(12)
#        , dh2(18)
        #y
        , sy()
        , tvtsara(1)
        , alignrp(18)
        , tstemt_sara_1(2)
        , shprp2(32)
        , mdrprg(12,"11-8 12-8 13-8 14-8 16-8 ")
        , f_ip([41,47])
        , mdrp0rg(24)
        , alignrp(26)
        , mdrprg(36)
        , tstemt_sara_2(8)
        , shprp2(6)
        , iy()
#        , dh1(21)
#        , dh2(15)
        , dx(25,-16)
        ),

    'uni0E4B':    #MAI CHATTAWA
        packline(""
        , mdap(10)
        , mdrp0rg(11)
        , alignrp(7)
        , tstemt_sara0_2(1)
        , alignrp(5)
        , mdrprg(3)
        , ix()
        #y  
        , sy()
        , tvtwanayuk(0)
        , mdrp0rg(11)
        , alignrp(2)
        , tstemt_sara0_1(8)
        , alignrp(5)
        , mdrprg(7)
        , iy()
        ),

    'base.uni0E4B.low':    #MAI CHATTAWA
        packline(""
        , mdap(10)
        , mdrp0rg(11)
        , alignrp(7)
        , tstemw_sara0_2(1)
        , alignrp(5)
        , mdrprg(3)
        , ix()
        #y  
        , sy()
        , tvtsara(0)
        , mdrp0rg(11)
        , alignrp(2)
        , tstemw_sara0_1(8)
        , alignrp(5)
        , mdrprg(7)
        , iy()
        ),

    'uni0E4C':    #THANTHAKAT
        packline(""
        , mdap(17)
        , mdrprg(11)
        , mdrprg(3)
        , f_ip([29,23])
        , ix()
        #y  
        , sy()
        , tvtwanayuk(0)
        , mdrp0rg(6)
        , f_ip([20,26])
        , mdrpmrg(10)
        , tstemt_sara_2(14)
        , iy()
        ),

    'base.uni0E4C.low':    #THANTHAKAT
        packline(""
        , mdap(18)
        , mdrprg(12)
        , headsara2(3,[30,24])
        , ix()
        #y  
        , sy()
        , tvtsara(0)
        , headsara1(6,[21,27])
        , mdrpmrg(11)
        , tstemt_sara_2(15)
        , iy()
        ),

    'uni0E4D':    #NIKHAHIT
        packline(""
        , mdap(9)
        , head2(3,[21,15])
        , ix()
        #y
        , sy()
        , tvtsara(0)
        , head1(6,[12,18])
        , iy()
        ),

    'base.uni0E4D.high':    #NIKHAHIT
        packline(""
        , mdap(9)
        , mdrprg(8)
        , f_ip([21,15])
        , ix()
        #y
        , sy()
        , tvtwanayuk(0)
        , mdrprg(6)
        , f_ip([12,18])
        , iy()
        ),

    'uni0E4E':    #YAMAKKAN
        packline(""
        , mdap(15)
        , mdrp0rg(9)
        , f_ip([24,33,7])
        , tstemw_sara_1(20)
        , mdrp0rg(4)
        , tstemw_sara_1(29)
        , ix()
        #
        , sy()
        , tvtsara(0)
        , tstemt_sara_1(33)
        , mdrp0rg(12)
        , f_ip([24])
        , tstemt_sara_2(17)
        , mdapr(24)
        , tstemt_sara_2(25)
        , f_ip([7])
        , iy()
        ),

    'uni0E4F':    #FONGMAN
        packline(""
        , mdapr(3) 
        , tstemw0_1(21)
        , mdrpmrw(27)
        , srp0(3)
        , mdrp0rg(9)
        , tstemw0_2(15)
        , mdrpmrw(33)
        , add_ip(27,33,[45,39])
        , ix()
        #y  
        , sy()
        , mdapr(0) 
        , tstemw0_1(12)
        , mdrpmrw(24)
        , srp0(0)
        , mdrp0rg(6)
        , tstemw0_2(18)
        , mdrpmrw(30)
        , add_ip(30,24,[36,42])
        , iy()
        ),

    'uni0E50':    #THAI DIGIT ZERO
        packline(""
        , tgf_112(24,3,21)
        , tgr_112(25,15,9)
        , ix()
        #y  
        , sy()
        , mdap(24)
        , tvtnc(6)
        , tstemt_2(18)
        , srp0(24)
        , tvbc(0)
        , tstemt_1(12)
        , iy()
        ),

    'uni0E51':    #THAI DIGIT ONE
        packline(""
        , tgf_112(48,3,22)
        , tgr_112(49,16,9)
        , ip_round(3,16,33)
        , mdapr(33)
        , mdrprg(13)
        , head2(27,[45,39])
        , ix()
        , dh1(30)
        #y  
        , sy()
        , mdapr(13)
        , tstemtc_2(12)
        , tvtnc(6,[0,3,22,16,9])
        , tstemtc_2(19)
        , mdapr(0)
        , tstemtc_1(25)
        , mdrp0rg(30)
        , xhead0(42,36,direction='-')
        , iy()
        , dh1(27)
        , dh2(33)
        ),

    'uni0E52':    #THAI DIGIT TWO
        packline(""
        , tgf_162(54,4,12)
        , mdrp0rg(35,"9+8 10+8 ")
        , tstemw_1(24)
        , head1(29,[51,45])
        #
        , tgr_140(55,17,41)
        , add_ip(35,41,[37,38,39,20,21,22])
        , ix()
        , dh1(26)
        , dh2(32)
        #y  
        , sy()
        , mdap(0)
        , tstemt_1(16)
        , tvtnc(39)
        , alignrp(37)
        , mdrpmrg(9)
        , tstemt_2(20)
        , shprp2(22)
        , mdrp0mrg(21,"9-3 10-3 11-3 12-3 17-3 18-3 19-3 20-3 21-3 ")
        , mdrpb(38)
        , mdrp0rg(26)
        , mdapr(26)
        , head2(32,[42,48])
        , iy()
        , dh2(29)
        ),

    'uni0E53':    #THAI DIGIT THREE
        packline(""
        , tgf_112(62,35,17)
        , xhead2(26,53,59)
        #
        , tgr_112(63,4,47)
        , ip_round(35,4,11)
        , tstemw_1(10)
        , f_ip([41])
        , ix()
        , dh1(23)
        , dh2(29)
        #y  
        , sy()
        , mdap(1)
        , tvtnc(44,[35,17,41,4,47,11])
        , alignrp(38)
        , tstemt_2(7)
        , shprp2(14)
        , mdapr(11)
        , srp0(1)
        , tvbc(29)
        , head1(23,[50,56])
        , iy()
        , dh2(26)
        ),


    'uni0E54':    #THAI DIGIT FOUR
        packline(""
        , tgf_112(58,10,25)
        , mdapr(18)
        , ip_round(25,18,39)
        , mdapr(39)
        , mdrprg(45)
        , head2(33,[55,49,30,42])
        , ix()
        , dh1(36)
        #y  
        , sy()
        , mdap(0)
        , tstemt_1(45)
        , tvtn(14,[10,25])
        , mdrprg(17)
        , tstemt0_2(21)
        , mdrp0mrw(36)
        , mdapr(36)
        , head2(42,[46,52])
        , srp0(0)
        , tvbc(7)
        , tstemtc_1(28)
        , iy()
        , dh1(33)
        , dh2(39)
        ),

    'uni0E55':    #THAI DIGIT FIVE
        packline(""
        , tgf_112(80,10,35)
        , mdapr(28)
        , ip_round(35,28,49)
        , mdapr(49)
        , mdrprg(55)
        , head2(43,[65,59,40,52])
        , mdrp0rg(21)
        , head2(15,[77,71])
        , ix()
        , dh1(46,18)
        #y  
        , sy()
        , mdap(0)
        , tstemt_1(55)
        , tvtn(23,[10,35])
        , alignrp(13)
        , mdrprg(27)
        , xhead2(18,74,68,dstr="18-8 32-8 38+8 ")
        , srp0(23)
        , tstemt0_2(31)
        , mdrp0mrw(46)
        , mdapr(46)
        , head2(52,[56,62])
        , srp0(0)
        , tvbc(7)
        , tstemtc_1(38)
        , iy()
        , dh1(43,15)
        , dh2(49,21)
        ),

    'uni0E56':    #THAI DIGIT SIX
        packline(""
        , mdap(27)
        , tstemt_sara_1(34)
        , mdrp0rg(30)
        , mdrpg(31)
        , srp0(27)
        , mdrp0rg(6)
        , head1(12,[52,46])
        #
        , tgr_112(56,20,40)
        , ix()
        , dh1(9)
        #y  
        , sy()
        , mdap(55)
        , tvtnc(37,[26,34]) 
        , tstemt_2(23)
        , mdrp0rg(31)
        , mdrpg(30)
        , srp0(55)
        , tvbc(0)
        , tstemt_1(17)
        , mdrp0rg(3)
        , head1(9,[43,49])
        , iy()
        , dh1(6)
        , dh2(12)
        ),

    'uni0E57':    #THAI DIGIT SEVEN
        packline(""
        , mdap(35)
        , tstemw_1(18)
        , xhead2(26,63,69)
        #
        , tgr_140(73,54,56)
        , ip_round(35,54,5)
        , tstemw_1(47)
        , ip_round(35,5,12)
        , tstemw_1(11)
        , f_ip([41])
        , ix()
        , dh1(23)
        , dh2(29)
        #y  
        , sy()
        , mdap(1)
        , tstemt_1(50)
        , f_ip([2])
        , tvtnc(44,[35,18,41,5,17])
        , alignrp(38)
        , mdrprg(56)
        , tstemt_2(8)
        , shprp2(15)
        , srp0(1)
        , tvbc(29)
        , head1(23,[60,66])
        , ip_round(23,15,12)
        , iy()
        , dh2(26)
        ),

    'uni0E58':    #THAI DIGIT EIGHT
        packline(""
        , mdapr(4)
        , tstemw_1(19)
        #
        , mdapr(12)
        , mdrp0rg(44)
        , head2(38,[65,69])
        , ip_round(19,38,24)
        , tstemt_sara_1(54)
        , add_ip(54,38,[27,52,29,50])
        , ix()  
        , dh1(41)
        #y  
        , sy()
        , mdap(1)
        , tstemt_1(22)
        , tvtn(8,[4,19])
        , mdrprg(11)
        , tstemt_2(15)
        , ip_round(15,22,41)
        , head2(35,[56,62])
        , srp0(1)
        , tvbc(47)
        , tstemt_1(32)
        , mdrp0rg(27)
        , tstemt_2(52)
        , iy()
        , dh1(38)
        ),

    'uni0E59':    #THAI DIGIT NINE
        packline(""
        , tgf_112(69,25,8)
        , xhead2(16,60,66)
        , f_ip([31])
        , mdapr(1,"9-8 14+8 15+8 ")
        , mdrpg(2)
        , tstemw0_1(0)
        , mdrpg(56)
        , add_ip(2,56,[31])
        , mdapr(43)
        , add_ip(56,43,[34,51,39,46])
        , ix()  
        , dh1(13)
        , dh2(19)
        #y  
        , sy()
        , mdap(1)
        , tvtnc(34,[25,8,2,56])
        , alignrp(28)
        , mdrprg(42)
        , tstemt_2(51)
        , shprp2(5)
        , mdrp0rg(46)
        , tstemt_1(39)
        , srp0(1)
        , tvbc(19)
        , head1(13,[57,63])
        , iy()
        , dh1(16)
        ),

    'uni0E5A':      #ANGKHANKHU
        packline(""
        , srp0(40)
        , mdrp0rg(8,"9-8 10-8 17-8 ")   #gap_112
        , head1(14,[33,27,17])
        , tgr_160(41,37,39)
        , mdrp0rg(1,"9-8 10-8 11-8 ")
        , alignrp(22)
        , tstemw_1(23)
        , ix()
        , dh1(19)
        #y  
        , sy()
        , mdap(1)
        , alignrp(37)
        , tvt2(23)
        , shprp2(39)
        , tvtc2(11)
        , head2(17,[24,30])
        , mdrp0rg(19)
        , tstemt_2(5)
        , iy()
        , dh2(14)
        ),

    'uni0E5B':      #KHOMUT
        packline(""
        , tgf_112(88,3,29)
        , mdrp0rg(15)
        , head1(23,[85,79])
        , tstemtc_1(9)
        , mdapr(56)
        , add_ip(9,56,[55,35,73,41,67,47,61])
        , ix()
        , dh1(18)
        , dh2(12)
        #y  
        , sy()
        , mdapr(6)
        , tstemt_2(26)
        , mdapr(88)
        , tvbc(0)
        , tstemt0_1(32)
        , mdrp0mrw(12) 
        , mdapr(12)
        , head1(18,[76,82])
        , add_ip(26,32,[38,44,50,41,47,73,67,61,70,64,55])
        , mdapr(55)
        , tstemt_2(58)
        , iy()
        , dh1(15)
        ),

    }



#++++++++++++++++++++++++++++++

#----- MODIFY pseudo_code_dict BY -----------
#----- SUBSTITUTE FUNCTION IN TEXT FORM -----
#----- TO REAL pseudo_code ------------------
from dttcmd import *

self_func = []
for i in dir():
    if callable(eval(i)): self_func.append(i)

for i in pseudo_code_dict.keys():
    p_list = pseudo_code_dict[i].split('\n')
    for j in range(len(p_list)):
        if '(' in p_list[j]:
            if p_list[j].split('(',1)[0] in self_func:
                l = [n for n in range(len(p_list[j])) if p_list[j][n] == ')']
                t = p_list[j][:l[-1]+1]
                p_list[j] = p_list[j].rep_listace(t, eval(t))
    pseudo_code_dict[i] = '\n'.join(p_list)

